function [r,m] = check_dem(n1,n2,tol)
% Compare two dem files and calculate the sqaure of the
% difference weighted sqrt(int(t=t1,t2)|x1(t)-x2(t)|^2)
% if tol exists return true or false if the differnce is less
% otherwise return the difference
% Check that the times are similar
if exist(n1)==2
  fid1 = fopen(n1);
else
  fid1 = fopen(['/home/jim/dem/data/' n1]);
end
if exist(n2)==2
  fid2 = fopen(n2);
else
  fid2 = fopen(['/home/jim/dem/data/' n2]);
end
[d1,t1,s1] = decode_dem(fid1,inf);
fclose(fid1);
[d2,t2,s2] = decode_dem(fid2,inf);
fclose(fid2);
if norm(t1-t2) > eps 
  error('Times are too different')
end
d = (d1-d2).^2;
t = sum(sum(d,1),2);
m = sqrt(max(d(:)));
dt = diff((t1+t2)/4);
dt = [dt 0] + [0 dt];
e = sqrt(dt(:)'*t(:)/sum(dt));

if nargin<3
  r = e;
else
  r = e<tol;
end