function [d,t,s] = decode_dem(fid,n,dims)
% read upto n time steps of information from a dem file fp
% d is the data 3*np*n np is number of particles
% t the time steps
% s the program steps
% default for n is 1
% n can be +inf

if nargin < 2
  n=1;
end

if nargin <3
  dims = 3;
end

dims = dims+1;

i = 0;
while(~feof(fid) & i<n)
  i = i+1;
  a=fscanf(fid,' step %f time %f \n'); 
  s(i)=a(1);
  t(i)=a(2);
  [r np]=fscanf(fid,' %f %f %f %f \n');
  r = reshape(r,dims,np/dims);
  d(:,r(1,:),i) = r(2:dims,:); % Save the particle info in order
  if any(r(1,:)~=(1:size(r,2)))
    disp(['Particles out of order step ' ...
	  num2str(s(i)) ' time ' num2str(t(i))]);
    keyboard
  end
end
