function [c,r] = fitcircle(p,q,r,s)
% find the centre of a circle passing through the points p and q
% if s is absent or equal to 'radius'  r specifies the radius
% otherwise it specifies the starting angle to the horizontal
% all may be column arrays
if nargin < 4
  s = 'radius';
end
if strcmp(s,'radius');
  m = p-q;
  m = m./repmat(sqrt(sum(m.^2)),[2 1]);
  n = [m(2,:);-m(1,:)];
  n=n./repmat(sqrt(sum(n.^2)),[2 1]);%generate an orthogonal vector
  l = r.*sqrt(1-sum((p-q).^2)./(4*r.^2));
  c = (p+q)/2 + repmat(l,[2 1]).*n; % Mid point of circle  
  if(~isreal(c)) 
    error('Circle does not exist')
  end
elseif strcmp(s,'angle');
  dp = p-q;
  theta = (r-90)*2*pi/360;
  r = +dp'*dp/2/(dp(1)*cos(theta)+dp(2)*sin(theta));
  c = p - r*[cos(theta);sin(theta)];
  r = abs(r);
else
  error('Unknown request to fit circle parameter')
  
end
    