function  cylinder_geom(length,radius)
% Create a simple cylinder geometry of specified length and radius

% Cylinder axis is the z axis
boundary(1).v      = [[1;0;0] [0;1;0]];
boundary(1).s      = [0 radius]; 
boundary(1).min    = [-radius;-radius;-length/2];
boundary(1).max    = [radius;radius;length/2];
boundary(1).name   = 'cylinder';
boundary(1).type   = 'p_cylinder';

boundary(2).v      = [0;0;1];
boundary(2).s      = []; 
boundary(2).min    = [-radius;-radius;length/2];
boundary(2).max    = [radius;radius;length/2];
boundary(2).name   = 'top wall';
boundary(2).type   = 'zp_plane';

boundary(3).v      = [0;0;-1];
boundary(3).s      = []; 
boundary(3).min    = [-radius;-radius;-length/2];
boundary(3).max    = [radius;radius;-length/2];
boundary(3).name   = 'bottom wall';
boundary(3).type   = 'zm_plane';

write_geometry('Simple cylinder', boundary,[],...
    '/home/jim/dem/data/cylinder.geom') % Now write this out to a file
  