function  [curve,width] = miyanomori
% return the curve describing miyanomori ski jump and the width information
SRT = 1; % Straight line
ARC = 2; % Circular arc
CBS = 3; % Cubic spline
% Negative radius means circle centre is below the line 
% Describe the xz curve
curve(1).name = 'end runout';
curve(1).type = SRT;
curve(1).p    = [  -230.900;200.214]; % Start point
curve(1).q    = [];                   % End point
curve(1).dp   = [];                   % difference
curve(1).l    = [];                   % arc length
curve(1).a    = [];                   % angle
curve(1).c    = [];                   % centre
curve(1).r    = [];                   % radius
curve(1).n    = [];                   % surface normal
curve(2).name = 'end runout arc';
curve(2).type = ARC;
curve(2).p    = [  -214.400;200.214];
curve(2).r    = -100;
curve(3).name = 'runout upslope';
curve(3).type = SRT;
curve(3).p    = [  -207.400;199.97];
curve(4).name = 'runout upslope arc';
curve(4).type = ARC;
curve(4).p    = [  -164.400;196.96];
curve(4).r    = 100;
curve(5).name = 'flat runout';
curve(5).type = SRT;
curve(5).p    = [  -157.400;196.714];
curve(6).name = 'final landing arc';
curve(6).type = ARC;
curve(6).p    = [  -130.900;196.714 ];
curve(6).r    = 89.5;
curve(7).name = 'landing flat';
curve(7).type = SRT;
curve(7).p    = [   -78.293;213.807];
curve(8).name = 'landing max r';
curve(8).type = ARC;
curve(8).p    = [   -62.113;225.563];
curve(8).r    =  -225;
curve(9).name = 'landing mid r';
curve(9).type = ARC;
curve(9).p    = [   -49.758;233.927];
curve(9).r    =  -222.175;
curve(10).name = 'landing min r';
curve(10).type = ARC;
curve(10).p    = [   -29.806;245.101];
curve(10).r    =  -112.059;
curve(11).name = 'takeoff drop';
curve(11).type = SRT;
curve(11).p    = [     0    ;254.930];
curve(12).name = 'takeoff flat';
curve(12).type = SRT;
curve(12).p    = [     0    ;257.460];
curve(13).name = 'takeoff arc';
curve(13).type = ARC;
curve(13).p    = [     6.293;258.626];
curve(13).r    =  86.357;
curve(14).name = 'initial takeoff';
curve(14).type = SRT;
curve(14).p    = [    41.315;273.673];
curve(14).q    = [    79.339;301.299];

curve=connect_curve(curve); % Calculate additional points
curve=circle_info(curve);   % Calculate the circle data
curve=srt_info(curve);      % Calculate the straight line data

width = [-inf -230.9 -130.9 0 eps 35.022 79.339 inf
  25   25     25   8 5  3      3       3];
