function c = offset_curve(c,radius); % Allow for the radius of the balls
% Allow for the finite thickness of the balls.
% Since input points are only accurate to 1mm points after shift
% need only be close to 1mm
% any points that are closer than this are made equal by averaging
SRT = 1; % Straight line
ARC = 2; % Circular arc
CBS = 3; % Cubic spline

tol = 0.001; % Set tolerance to 1mm

for i=1:length(c)
  switch c(i).type
  case SRT % A straight line involves a simple shift
    c(i).p = c(i).p - radius*c(i).n; % Offset the points along the normal
    c(i).q = c(i).q - radius*c(i).n; 
  case ARC % An arc involves adjusting the radius
    r = c(i).r;
    c(i).r = r-radius; % Adjust the radius
    c(i).p = c(i).p -(c(i).p-c(i).c)*radius/r; % Adjust the points
    c(i).q = c(i).q -(c(i).q-c(i).c)*radius/r;
    c(i).l = abs(c(i).r)*c(i).a;
    c(i).dp = c(i).q-c(i).p;
    x(2*i-1) = c(i).p(1);y(2*i-1) = c(i).p(2);
    x(2*i)   = c(i).q(1);y(2*i)   = c(i).q(2);
  end
  if i > 1  % check adjacent points for similarity
    if norm(c(i).p-c(i-1).q) < tol
      m = (c(i).p+c(i-1).q)/2;
      c(i).p = m;
      c(i-1).q = m;
    end
  end
end
%x = zeros(2*length(c),1);
%y = zeros(2*length(c),1);
% $$$ x(2*i-1) = c(i).p(1);y(2*i-1) = c(i).p(2);
% $$$ x(2*i)   = c(i).q(1);y(2*i)   = c(i).q(2);
% $$$ Mx = repmat(x,[1 2*length(c)]);
% $$$ Mx = Mx-Mx';
% $$$ My = repmat(y,[1 2*length(c)]);
% $$$ My = My-My';
% $$$ M = tril(sqrt(Mx.^2+My.^2))
% $$$ f = find((M>0) & (M<0.001)); % Find the points that are nearly equal
% $$$ keyboard
