function [ay,ady] =  calc_curve(curve,ax)
% Calculate the values of a curve and it's derivativs at points x

SRT = 1; % Straight line
ARC = 2; % Circular arc
CBS = 3; % Cubic spline

numl= length(curve); % Number of line segements
for i=1:length(curve)
  cx(i) = curve(i).p(1);  
end

n = length(ax);

ax = ax(:);
ay = zeros(n,1);
ady = zeros(n,1);

for i =1:n
  x = ax(i);
  h=hash(x,cx);
  p = curve(h).p;
  q = curve(h).q;
  dp = curve(h).dp;
  
  switch curve(h).type
  case SRT, % Straight line
    dy = dp(2)/dp(1); 
    y = p(2)+dy*(x-p(1));
  case ARC,             % A circular arc of specified radius
    r = curve(h).r;
    c = curve(h).c;
    y = c(2) - r*sqrt(1 - (x-c(1))^2/r^2);
    dy = (x-c(1))/r/sqrt(1 - (x-c(1))^2/r^2);
  case CBS,
  y1d = dx1/2*tan(an(1,h)/360*2*pi); % Calc the gradients
    y2d = dx1/2*tan(an(2,h)/360*2*pi);
    a = (y1+y2)/2-(y2d-y1d)/4;
    b = 3*(y2-y1)/4-(y1d+y2d)/4;
    c = (y2d-y1d)/4;
    d = (y1d+y2d)/4 + (y1-y2)/4;
    %if abs(a+b+c+d - y2)>eps error; end
    %if abs(a-b+c-d - y1)>eps error; end
    %if abs(b+2*c+3*d - y2d)>100*eps error; end
    %if abs(b-2*c+3*d - y1d)>100*eps error; end
    x = (2*x-(x1+x2))/dx1;
    y = a + x.*(b + x.*(c+x*d)); 
    dy = 2/dx1*(b + x.*(2*c+x*3*d));
    ddy = 2/dx1*2/dx1*(2*c+x*6*d);
    r=(1+dy^2)^3/2/ddy;
  end
  ay(i) = y;
  ady(i) = dy;
end

