function plot_ang(n, a, dims)
% Plot the data in the log file n
% Plot radius and x,y angle
% a specifies what fractions of radius to plot

if nargin < 1
  n = 'test.position'
end

if nargin < 2
  a = [];
end

if nargin < 3
  dims = 2;
end

base = '/home/jim/dem/';
fid = fopen(filename(n,{base, [base 'data/'], [base 'testfiles/']}));
[d,t,s] = decode_dem(fid,inf,dims);
fclose(fid);
fo = 1:2:size(d,3);
d(:,:,fo) = [];
t(fo) = [];
s(fo) = [];
nd = size(d,1);  % Dimensions of data
np = size(d,2);  % Number of particles
nt = size(d,3);  % Number of time steps
title(['Data from ' n]);
x = reshape(d(1,:,:),np,nt);
y = reshape(d(2,:,:),np,nt);
r = sqrt(x.^2+y.^2);
ang = unwrap(atan2(y,x),[],2);
ang = ang - repmat(ang(:,1),[1 nt]); % Subtract off initial angle
mdw = mean(ang(:,nt))/(nt-1); % Final mean
ang = ang - repmat(mdw*(0:nt-1),[np 1]);
max_r = max(r(:,1));
w_r = a * max_r;

if length(a) == 0
  s = 1:np;
else
  s = zeros(length(w_r),1);
  for n = 1:length(w_r)
    [dum s(n)] = min((r(:,1)-w_r(n)).^2);
  end
end
subplot(2,1,1)
plot(t,r(s,:))
title('radius')
subplot(2,1,2)
plot(t,ang(s,:))
title(['angle with mean velocity ' num2str(mdw) ' subtracted'])
