function plotcuboid (x,n)
% plotcuboid (x,n)
% Plot a cuboid with dimensions x with lines n in each direction
if nargin < 2
	n = 2;
end
if nargin < 1
  x = 1;
end
if length(x) == 1
	x = ones(1,3)*x;
end
if length(n) == 1
	n= ones(1,3)*n;
end

% generate the points 
nx = ((0:1/(n(1)-1):1)-.5)*x(1);
ny = ((0:1/(n(2)-1):1)-.5)*x(2);
nz = ((0:1/(n(3)-1):1)-.5)*x(3);
ox = ones(1,n(1));
oy = ones(1,n(2));
oz = ones(1,n(3));
tx  = ones(n(2),n(3))*x(1)/2;
ty  = ones(n(1),n(3))*x(2)/2;
tz  = ones(n(1),n(2))*x(3)/2;

surface(oy'*nx, ny'*ox, oy'*ox*x(3)/2,'facecolor','none')
surface(oy'*nx, ny'*ox, -oy'*ox*x(3)/2,'facecolor','none')
surface(oz'*nx, oz'*ox*x(2)/2, nz'*ox, 'facecolor','none')
surface(oz'*nx, -oz'*ox*x(2)/2, nz'*ox, 'facecolor','none')
surface(oz'*oy*x(1)/2, oz'*ny,  nz'*oy, 'facecolor','none')
surface(-oz'*oy*x(1)/2, oz'*ny,  nz'*oy, 'facecolor','none')
