function plotcylinder (length, radius, n, m, k);
% plotcylinder (length, radius, n, m, k)
% Axis along which to plot the cylinder including cylinder length
% plot a cylinder with center length radius and gridding of n
% n is number of circular points
% m is number of z points
% k is number of radial points
if nargin < 5
  k = 2;
end
if nargin < 4
  m = 2;
end
if nargin < 3
  n = 10;
end
if nargin < 2
  radius = 1;
end
if nargin <1
  length=1; % Length one along the z axis
end

sc = (0:1/(k-1):1)';
phi = (0:1/(n-1):1)*2*pi;
cosphi = cos(phi); cosphi(1) = 1; cosphi(n) = 1;
sinphi = sin(phi); sinphi(1) = 0; sinphi(n) = 0;
x = [sc;ones(m,1);sc]*cosphi;
y = [sc;ones(m,1);sc]*sinphi;
z = [zeros(k,1);(0:1/(m-1):1)';ones(k,1)]*ones(1,n)-0.5;
surface(radius*x,radius*y,length*z,'facecolor','none','edgecolor',[0 0 0]);
