
function [x,y,z]=plot_miyanomori(range,ml)
% x measures along the slope
% y across the slope
% and z is the height of the slope
if nargin < 1
  range = [-230.8 79.338];
  range = [-160 0];
elseif isempty(range)
  range = [-230.8 79.338];
  range = [-160 0];
end  
if nargin < 2
  ml=5;
end
  
% Widest point is twenty five meters
xpoints = ceil((range(2)-range(1))/ml);
ypoints = ceil(25/ml);
x = range(1):(range(2)-range(1))/(xpoints-1):range(2);

[curve width] = miyanomori; % Get the curve and width information
width(width==-Inf) = - 100000;
width(width==Inf) = 100000;
[z dz] = calc_curve(curve,x);  % Calculate height and gradient of the curve

y = zeros(length(x),ypoints);
w = interp1(width(1,:),width(2,:),x);   % Calculate the widths at this point
for i=1:length(x);
  y(i,:) = -w(i)/2:w(i)/(ypoints-1):w(i)/2; % make the grid fit exactly
end

z = repmat(z,[1 ypoints]); % get the heights
x = repmat(x(:),[1 ypoints]);
if nargout ==0
  surfl(x,y,z,'light');
  view(3)
  %view(3)
  %axis tight
  %axis equal
  x=[]
  y=[]
  z=[]
end
