function  [bd,gname,bounds,radius] = read_geometry(fname)
% Read a geometry file and create a boundary type
if nargin < 1
  fname = '/home/jim/dem/data/test.geom';
end
radius = -1; % What radius was the geometry constructed for
bounds = [];    % No range
%Now write the data to the file
% First write out the name list
fid = fopen(fname,'r');
[s x]=read_name_list(fid,'GEOMETRY_PARAM','GEOM_DIM',...
    {'GEOM_NAME','GEOM_TYPE','GEOM_RADIUS','GEOM_NUM','GEOM_BOUNDS'});
gname  = s{1};
gtype  = s{2};
radius = x{3};
bnum   = x{4};
bounds = x{5};

for i=1:bnum  
  [s x]=read_name_list(fid,'BOUNDARY_PARAM',...
      {'BD_NAME','BD_TYPE','BD_REGION','BD_S','BD_V','BD_W'});
  bd(i).name  = s{1};
  bd(i).type  = s{2};
  bd(i).range = x{3};
  bd(i).s     = x{4};
  bd(i).v     = x{5};
  bd(i).w     = x{6};
end
   
% Write out cut points
%fprintf(fid,' %i', gdim);fprintf(fid,',\n'); 
%fprintf(fid,[' ' ps], ix);fprintf(fid,',\n'); 
%fprintf(fid,[' ' ps], iy);fprintf(fid,',\n'); 
%fprintf(fid,[' ' ps], iz);fprintf(fid,',\n\n'); 

% write out count
%fprintf(fid,[' ' ps],index_c);fprintf(fid,',\n\n');

% write out boundary numbers
%for i=1:max(index_c(:))
%  fprintf(fid,[' ' ps],index_d(:,:,:,i));fprintf(fid,',\n');
%end
fclose(fid);
