function run_full_sim(n,name,nn)
% Generate all the files and execute a full simulation
% if no name is given generate a name from  the time, date and
% number of balls
% n is the actual number of balls to use in the simulation
% gzip the program output files afterwards to save disc space

if nargin < 1
  n = 100
end

if nargin < 2
  name = ['miya-' num2str(n) '-' date];
elseif isempty(name)
  name = ['miya-' num2str(n) '-' date];
end 

if nargin < 3
  nn=n;
end

disp(['Generating the files for an ' num2str(n) ...
      ' balls simulation called ' name]);
if nn~=n
  disp(['Simulation uses ' num2str(nn) 'balls']);
end
 
[n1,n2]=make_sim(name,nn,n,15,'/home/jim/matlab/dem/base.param');
cd ~/dem/data
cmd = ['dem < ' n1 '.param > ' n1 '.log'];
disp(cmd);unix(cmd);
disp('Clearing velocities')
clear_vel([n1 '.dump'])
cmd=['dem < ' n2 '.param > ' n2 '.log'];
disp(cmd);unix(cmd);
%display_dem(n1,[400 400],1,10,0,0,1)

cmd = ['gzip -f /home/jim/dem/data/' n2 '.velocity'];
unix(cmd);

display_dem(n2,[400 400],1,10,1,1,'mpeg')

cmd = ['gzip -f /home/jim/dem/data/' n2 '.position'];
unix(cmd);


