module col_props_mpi_def
  use col_props_f90_def, only:  col_props_t
  use user_col_props_s
  use mpi_main
contains
  subroutine init_col_props_mpi_def  
    !  implicit none
    type(col_props_t) :: d(2)
    type(mpi_datatype_t) :: datatype
    type(mpi_address_t)  addr1, addr2
    datatype = fmpi_get_datatype(d(1))
    if (datatype/=fmpi_col_props_t) then
       print('mpi datatypes do not match up in definition of col_props_t')
       call mpi_abort(666)
    end if
    
    call fmpi_address(d(1),addr1)  
    call fmpi_address(d(2),addr2)
    call fmpi_type_contiguous(addr2-addr1,FMPI_BYTE,fmpi_col_props_t)
    call fmpi_type_commit(fmpi_col_props_t)
  end subroutine init_col_props_mpi_def
end module col_props_mpi_def
