# 1 "ivec_and_rvec.F90"
# 1 "/home/jim/fortran/library/dimension.h" 1 
!Define preprocessor macros that define the dimension
!Default is Three dimensions
!Overide by compiling with -DTWODIM or defining 1 before this is included
!If the file is directly edited then the dependencies will cause the correct files
!to be recompiled so this is probably best
 
# 11


! Commands only for three dimensions use the macro CMD3() 








! Commands only for two dimensions use the macro 
# 28



# 2 "/home/jim/fortran/library/ivec_and_rvec.F90" 2 
module ivec_and_rvec
  use rvec_f90_def
  use ivec_f90_def

  interface operator(+)
     module procedure  &
          ivec_add_rvec, aivec_add_arvec, ivec_add_arvec, aivec_add_rvec,&
          rvec_add_ivec, arvec_add_aivec, rvec_add_aivec, arvec_add_ivec
  end interface
  interface operator(-)
     module procedure &
          ivec_sub_rvec, aivec_sub_arvec, ivec_sub_arvec, aivec_sub_rvec,&
          rvec_sub_ivec, arvec_sub_aivec, rvec_sub_aivec, arvec_sub_ivec
  end interface
  interface floor
     module procedure floor_rvec, floor_arvec
  end interface
  interface ceiling
     module procedure ceiling_rvec, ceiling_arvec 
  end interface
   interface operator(*)
     module procedure &
          ivec_mult_r, r_mult_ivec, aivec_mult_r, r_mult_aivec, &
          ivec_mult_ar, ar_mult_ivec, aivec_mult_ar, ar_mult_aivec
  end interface
contains
  
  function floor_rvec(a) result(r)
    type(rvec_t), intent(in) :: a
    type(ivec_t) r
    r%x = floor(a%x);r%y = floor(a%y);r%z = floor(a%z);
  end function floor_rvec
  function floor_arvec(a) result(r)
    type(rvec_t), intent(in) :: a(:)
    type(ivec_t) r(size(a))
    r%x = floor(a%x);r%y = floor(a%y);r%z = floor(a%z); 
  end function floor_arvec
  function ceiling_rvec(a) result (r)
    type(rvec_t), intent(in) :: a
    type(ivec_t) r
    r%x = ceiling(a%x);r%y = ceiling(a%y);r%z = ceiling(a%z); 
  end function ceiling_rvec
  function ceiling_arvec(a) result (r)
    type(rvec_t), intent(in) :: a(:)
    type(ivec_t) r(size(a))
    r%x = ceiling(a%x);r%y = ceiling(a%y);r%z = ceiling(a%z); 
  end function ceiling_arvec
! Rrv + ivec
  function rvec_add_ivec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b
    type(rvec_t) r
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function rvec_add_ivec
  function arvec_add_ivec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b
    type(rvec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function arvec_add_ivec
  function rvec_add_aivec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function rvec_add_aivec
  function arvec_add_aivec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function arvec_add_aivec

!ivec + rvec
  function ivec_add_rvec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b
    type(rvec_t) r
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function ivec_add_rvec
  function aivec_add_rvec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b
    type(rvec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function aivec_add_rvec
  function ivec_add_arvec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function ivec_add_arvec
  function aivec_add_arvec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function aivec_add_arvec

 

! Rrv - ivec
  function rvec_sub_ivec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b
    type(rvec_t) r
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function rvec_sub_ivec
  function arvec_sub_ivec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b
    type(rvec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function arvec_sub_ivec
  function rvec_sub_aivec(a,b) result (r)
    type(rvec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function rvec_sub_aivec
  function arvec_sub_aivec(a,b) result (r)
    type(rvec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function arvec_sub_aivec

!ivec - rvec
  function ivec_sub_rvec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b
    type(rvec_t) r
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function ivec_sub_rvec
  function aivec_sub_rvec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b
    type(rvec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function aivec_sub_rvec
  function ivec_sub_arvec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(rvec_t) , intent(in):: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function ivec_sub_arvec
  function aivec_sub_arvec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(rvec_t) , intent(in):: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function aivec_sub_arvec



 

! real times integer vectors
  function r_mult_ivec(a,b) result(r)
    real(r_kind), intent(in) :: a
    type(ivec_t), intent(in)    :: b
    type(rvec_t) r
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function r_mult_ivec
  function ivec_mult_r(a,b) result(r)
    type(ivec_t), intent(in)    :: a
    real(r_kind), intent(in) :: b
    type(rvec_t) r
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function ivec_mult_r
  function r_mult_aivec(a,b) result(r)
    real(r_kind), intent(in) :: a
    type(ivec_t), intent(in)    :: b(:)
    type(rvec_t) r(size(b))
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function r_mult_aivec
  function aivec_mult_r(a,b) result(r)
    type(ivec_t), intent(in)    :: a(:)
    real(r_kind), intent(in) :: b
    type(rvec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function aivec_mult_r




! real times integer vectors
  function ar_mult_ivec(a,b) result(r)
    real(r_kind), intent(in) :: a(:)
    type(ivec_t), intent(in)    :: b
    type(rvec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function ar_mult_ivec
  function ivec_mult_ar(a,b) result(r)
    type(ivec_t), intent(in)    :: a
    real(r_kind), intent(in) :: b(:)
    type(rvec_t) r(size(b))
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function ivec_mult_ar
  function ar_mult_aivec(a,b) result(r)
    real(r_kind), intent(in) :: a(:)
    type(ivec_t), intent(in)    :: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function ar_mult_aivec
  function aivec_mult_ar(a,b) result(r)
    type(ivec_t), intent(in)    :: a(:)
    real(r_kind), intent(in) :: b(size(a))
    type(rvec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function aivec_mult_ar
end module ivec_and_rvec
