# 1 "ivec_f90_def.F90"
# 1 "/home/jim/fortran/library/dimension.h" 1 
!Define preprocessor macros that define the dimension
!Default is Three dimensions
!Overide by compiling with -DTWODIM or defining 1 before this is included
!If the file is directly edited then the dependencies will cause the correct files
!to be recompiled so this is probably best
 
# 11


! Commands only for three dimensions use the macro CMD3() 








! Commands only for two dimensions use the macro 
# 28



# 2 "/home/jim/fortran/library/ivec_f90_def.F90" 2 
! Defines three dimensional integer vectors and overloaded operators
module ivec_f90_def
  use precision
  implicit none
  type, public :: ivec_t  ! Real(R_kind) vector
     integer x
     integer y
     integer z
  end type ivec_t

!  type(ivec_t), parameter :: null_ivec = ivec_t(0,0,0) SR2201BUG
  type(ivec_t) :: null_ivec = ivec_t(0,0,0)

  interface assignment(=)
     module procedure aivec_equ_aivec
  end interface

  interface operator(==)
     module procedure ivec_eq_ivec, aivec_eq_aivec
  end interface

  interface operator(/=)
     module procedure ivec_neq_ivec, aivec_neq_aivec 
  end interface

  interface operator(<) 
     module procedure le_ivec_ivec, le_ivec_aivec, le_aivec_ivec, le_aivec_aivec
  end interface

  interface operator(>) 
     module procedure ge_ivec_ivec, ge_ivec_aivec, ge_aivec_ivec, ge_aivec_aivec
  end interface

  interface operator(<=) 
     module procedure leq_ivec_ivec, leq_ivec_aivec, leq_aivec_ivec, leq_aivec_aivec
  end interface

  interface operator(>=) 
     module procedure geq_ivec_ivec, geq_ivec_aivec, geq_aivec_ivec, geq_aivec_aivec
  end interface

  interface operator(+)
     module procedure ivec_add_ivec, aivec_add_aivec, ivec_add_aivec, aivec_add_ivec
  end interface

  interface operator(-)
     module procedure neg_ivec, neg_aivec, &
          ivec_sub_ivec, aivec_sub_aivec, ivec_sub_aivec, aivec_sub_ivec
  end interface

  interface operator(*)
     module procedure &
          ivec_mult_i, i_mult_ivec, aivec_mult_i, i_mult_aivec, &
          ivec_mult_ai, ai_mult_ivec, aivec_mult_ai, ai_mult_aivec
  end interface

  interface max
     module procedure max_ivec
  end interface

  interface min
     module procedure min_ivec
  end interface
  interface sum
     module procedure sum_aivec
  end interface
  interface minval
     module procedure minval_aivec
  end interface
  interface maxval
     module procedure maxval_aivec
  end interface
  interface vec_to_array
     module procedure ivec_to_array, aivec_to_array
  end interface
  interface volume
     module procedure  ivec_volume
  end interface
  interface scalar_to_ivec
     module procedure  scalari_to_ivec
  end interface
contains
  function ivec_to_array(a) result(r)
    type(ivec_t), intent(in) :: a
    integer :: r(3)
    r = (/a%x,a%y,a%z/)
  end function ivec_to_array
  function aivec_to_array(a) result(r)
    type(ivec_t), intent(in) :: a(:)
    integer :: r(3,size(a))
    r(1,:) = a%x; r(2,:) = a%y; r(3,:) = a%z
  end function aivec_to_array


  subroutine aivec_equ_aivec(a,r)
    type(ivec_t), intent(in) :: r(:)
    type(ivec_t), intent(out):: a(size(r))
    a%x  = r%x; a%y = r%y; a%z = r%z
  end subroutine aivec_equ_aivec
  function ivec_eq_ivec(a,b) result(r)
    type(ivec_t),intent(in) :: a
    type(ivec_t),intent(in) :: b
    logical              :: r
    r = a%x==b%x .and. a%y==b%y .and. a%z==b%z
  end function ivec_eq_ivec
  function aivec_eq_aivec(a,b) result(r)
    type(ivec_t),intent(in) :: a(:)
    type(ivec_t),intent(in) :: b(size(a))
    logical              :: r(size(a))
    r = a%x==b%x .and. a%y==b%y .and. a%z==b%z
  end function aivec_eq_aivec
  function ivec_neq_ivec(a,b) result(r)
    type(ivec_t),intent(in) :: a
    type(ivec_t),intent(in) :: b
    logical              :: r
    r = a%x/=b%x .and. a%y/=b%y .and. a%z/=b%z
  end function ivec_neq_ivec
  function aivec_neq_aivec(a,b) result(r)
    type(ivec_t),intent(in) :: a(:)
    type(ivec_t),intent(in) :: b(size(a))
    logical              :: r(size(a))
    r = a%x/=b%x .and. a%y/=b%y .and. a%z/=b%z
  end function aivec_neq_aivec
  function neg_ivec(a)
    type(ivec_t) neg_ivec
    type(ivec_t) , intent(in):: a
    neg_ivec%x = -a%x;  neg_ivec%y = -a%y;  neg_ivec%z = -a%z
  end function neg_ivec
  function neg_aivec(a)
    type(ivec_t) , intent(in):: a(:)
    type(ivec_t) neg_aivec(size(a))
    neg_aivec%x = -a%x;  neg_aivec%y = -a%y;  neg_aivec%z = -a%z
  end function neg_aivec
! ivec + ivec
  function ivec_add_ivec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b
    type(ivec_t) r
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function ivec_add_ivec
  function aivec_add_ivec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b
    type(ivec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function aivec_add_ivec
  function ivec_add_aivec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b(:)
    type(ivec_t) r(size(b))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function ivec_add_aivec
  function aivec_add_aivec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b(size(a))
    type(ivec_t) r(size(a))
    r%x = a%x + b%x;  r%y = a%y + b%y;  r%z = a%z + b%z
  end function aivec_add_aivec
! ivec - ivec
  function ivec_sub_ivec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b
    type(ivec_t) r
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function ivec_sub_ivec
  function aivec_sub_ivec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b
    type(ivec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function aivec_sub_ivec
  function ivec_sub_aivec(a,b) result (r)
    type(ivec_t) , intent(in):: a
    type(ivec_t) , intent(in):: b(:)
    type(ivec_t) r(size(b))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function ivec_sub_aivec
  function aivec_sub_aivec(a,b) result (r)
    type(ivec_t) , intent(in):: a(:)
    type(ivec_t) , intent(in):: b(size(a))
    type(ivec_t) r(size(a))
    r%x = a%x - b%x;  r%y = a%y - b%y;  r%z = a%z - b%z
  end function aivec_sub_aivec
! integer times integer vectors
  function i_mult_ivec(a,b) result(r)
    integer, intent(in) :: a
    type(ivec_t), intent(in)    :: b
    type(ivec_t) r
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function i_mult_ivec
  function ivec_mult_i(a,b) result(r)
    type(ivec_t), intent(in)    :: a
    integer, intent(in) :: b
    type(ivec_t) r
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function ivec_mult_i
  function i_mult_aivec(a,b) result(r)
    integer, intent(in) :: a
    type(ivec_t), intent(in)    :: b(:)
    type(ivec_t) r(size(b))
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function i_mult_aivec
  function aivec_mult_i(a,b) result(r)
    type(ivec_t), intent(in)    :: a(:)
    integer, intent(in) :: b
    type(ivec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function aivec_mult_i
! integer times integer vectors
  function ai_mult_ivec(a,b) result(r)
    integer, intent(in) :: a(:)
    type(ivec_t), intent(in)    :: b
    type(ivec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function ai_mult_ivec
  function ivec_mult_ai(a,b) result(r)
    type(ivec_t), intent(in)    :: a
    integer, intent(in) :: b(:)
    type(ivec_t) r(size(b))
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function ivec_mult_ai
  function ai_mult_aivec(a,b) result(r)
    integer, intent(in) :: a(:)
    type(ivec_t), intent(in)    :: b(size(a))
    type(ivec_t) r(size(a))
    r%x = a * b%x;  r%y = a * b%y; r%z = a * b%z
  end function ai_mult_aivec
  function aivec_mult_ai(a,b) result(r)
    type(ivec_t), intent(in)    :: a(:)
    integer, intent(in) :: b(size(a))
    type(ivec_t) r(size(a))
    r%x = a%x * b;  r%y = a%y * b; r%z = a%z * b
  end function aivec_mult_ai
! Comparison for integers
  function le_ivec_ivec(r,s) ! Scalar vectors
    logical :: le_ivec_ivec
    type(ivec_t), intent(in) :: r,s
    le_ivec_ivec = r%x<s%x .and. r%y<s%y .and. r%z<s%z 
  end function le_ivec_ivec
  function le_aivec_ivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: le_aivec_ivec
    type(ivec_t), intent(in) :: s
    le_aivec_ivec = r%x<s%x .and. r%y<s%y .and. r%z<s%z 
  end function le_aivec_ivec
  function le_ivec_aivec(r,s) ! s is array r is scalar
    type(ivec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: le_ivec_aivec
    type(ivec_t), intent(in) :: r
    le_ivec_aivec = r%x<s%x .and. r%y<s%y .and. r%z<s%z 
  end function le_ivec_aivec
  function le_aivec_aivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: le_aivec_aivec
    type(ivec_t), intent(in), dimension(size(r)) :: s
    le_aivec_aivec = r%x<s%x .and. r%y<s%y .and. r%z<s%z 
  end function le_aivec_aivec
! Greater than function
  function ge_ivec_ivec(r,s) ! Scalar vectors
    logical :: ge_ivec_ivec
    type(ivec_t), intent(in) :: r,s
    ge_ivec_ivec = r%x>s%x .and. r%y>s%y .and. r%z>s%z
  end function ge_ivec_ivec
  function ge_aivec_ivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: ge_aivec_ivec
    type(ivec_t), intent(in) :: s
    ge_aivec_ivec = r%x>s%x .and. r%y>s%y .and. r%z>s%z 
  end function ge_aivec_ivec
  function ge_ivec_aivec(r,s) ! s is array r is scalar
    type(ivec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: ge_ivec_aivec
    type(ivec_t), intent(in) :: r
    ge_ivec_aivec = r%x>s%x .and. r%y>s%y .and. r%z>s%z 
  end function ge_ivec_aivec
  function ge_aivec_aivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: ge_aivec_aivec
    type(ivec_t), intent(in), dimension(size(r)) :: s
    ge_aivec_aivec = r%x>s%x .and. r%y>s%y .and. r%z>s%z 
  end function ge_aivec_aivec
! Comparison for integers
  function leq_ivec_ivec(r,s) ! Scalar vectors
    logical :: leq_ivec_ivec
    type(ivec_t), intent(in) :: r,s
    leq_ivec_ivec = r%x<=s%x .and. r%y<=s%y .and. r%z<=s%z
  end function leq_ivec_ivec
  function leq_aivec_ivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: leq_aivec_ivec
    type(ivec_t), intent(in) :: s
    leq_aivec_ivec = r%x<=s%x .and. r%y<=s%y .and. r%z<=s%z 
  end function leq_aivec_ivec
  function leq_ivec_aivec(r,s) ! s is array r is scalar
    type(ivec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: leq_ivec_aivec
    type(ivec_t), intent(in) :: r
    leq_ivec_aivec = r%x<=s%x .and. r%y<=s%y .and. r%z<=s%z 
  end function leq_ivec_aivec
  function leq_aivec_aivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: leq_aivec_aivec
    type(ivec_t), intent(in), dimension(size(r)) :: s
    leq_aivec_aivec = r%x<=s%x .and. r%y<=s%y .and. r%z<=s%z 
  end function leq_aivec_aivec
! Greater than function
  function geq_ivec_ivec(r,s) ! Scalar vectors
    logical :: geq_ivec_ivec
    type(ivec_t), intent(in) :: r,s
    geq_ivec_ivec = r%x>=s%x .and. r%y>=s%y .and. r%z>=s%z 
  end function geq_ivec_ivec
  function geq_aivec_ivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in),dimension(:) :: r
    logical, dimension(size(r)) :: geq_aivec_ivec
    type(ivec_t), intent(in) :: s
    geq_aivec_ivec = r%x>=s%x .and. r%y>=s%y .and. r%z>=s%z 
  end function geq_aivec_ivec
  function geq_ivec_aivec(r,s) ! s is array r is scalar
    type(ivec_t), intent(in),dimension(:) :: s
    logical, dimension(size(s)) :: geq_ivec_aivec
    type(ivec_t), intent(in) :: r
    geq_ivec_aivec = r%x>=s%x .and. r%y>=s%y .and. r%z>=s%z 
  end function geq_ivec_aivec
  function geq_aivec_aivec(r,s) ! r is array s is scalar
    type(ivec_t), intent(in), dimension(:) :: r
    logical, dimension(size(r)) :: geq_aivec_aivec
    type(ivec_t), intent(in), dimension(size(r)) :: s
    geq_aivec_aivec = r%x>=s%x .and. r%y>=s%y .and. r%z>=s%z 
  end function geq_aivec_aivec
  function min_ivec(a,b)
    type(ivec_t) :: min_ivec
    type(ivec_t),intent(in) :: a,b
    min_ivec%x = min(a%x,b%x);
    min_ivec%y = min(a%y,b%y);min_ivec%z = min(a%z,b%z)
  end function min_ivec
  function max_ivec(a,b)
    type(ivec_t) :: max_ivec
    type(ivec_t),intent(in) :: a,b
    max_ivec%x = max(a%x,b%x);
    max_ivec%y = max(a%y,b%y);max_ivec%z = max(a%z,b%z)
  end function max_ivec

  function sum_aivec(a) result(r)
    type(ivec_t),intent(in) :: a(:)
    type(ivec_t) :: r
    r%x = sum(a%x);r%y = sum(a%y);r%z = sum(a%z)
  end function sum_aivec
  function minval_aivec(a)
    type(ivec_t) :: minval_aivec
    type(ivec_t),intent(in) :: a(:)
    minval_aivec%x = minval(a%x)
    minval_aivec%y = minval(a%y);minval_aivec%z = minval(a%z)
  end function minval_aivec
  function maxval_aivec(a)
    type(ivec_t) :: maxval_aivec
    type(ivec_t),intent(in) :: a(:)
    maxval_aivec%x = maxval(a%x)
    maxval_aivec%y = maxval(a%y);maxval_aivec%z = maxval(a%z)
  end function maxval_aivec
  function ivec_volume(a) ! Volume of a region
    type(ivec_t),intent(in) :: a
    integer :: ivec_volume
    ivec_volume = a%x*a%y *a%z
  end function ivec_volume
  function scalari_to_ivec(a) result (r)
    integer, intent(in) :: a
    type(ivec_t) r
    r = ivec_t(a,a,a)
  end function scalari_to_ivec
end module ivec_f90_def
