# 1 "nag_iostat.F90"
!Define the linux error numbers

# 1 "/usr/src/linux-2.0.36/include/asm-i386/errno.h" 1 




































































































































# 4 "/home/jim/fortran/library/nag_iostat.F90" 2 
!#ifndef 
!#define 
! Copyright Jim McElwaine March 1998
! Display iostat error messages for NAG compiler
module nag_iostat
  USE f90_iostat ! The NAG module that defines the constants
  implicit none
  private
  public print_iostat
contains
  subroutine print_iostat(iostat,fp,str)
    integer, intent(in) :: iostat
    integer, intent(in) :: fp
    character(len=*), intent(in) :: str
    select case(iostat)
    case (IOERR_EOR)
       write(fp,'(1X,A)')str//": End of record"
    case (IOERR_EOF)
       write(fp,'(1X,A)')str//": End of file"
    case (IOERR_OK)
       write(fp,'(1X,A)')str//": No error"
    case(IOERR_BUFFER_OVERFLOW)
       write(fp,'(1X,A)')str//": Buffer overflow on output"
    case(IOERR_INTERNAL_FILE_OVERFLOW)
       write(fp,'(1X,A)')str//": Internal file overflow"
    case(IOERR_BAD_SCALE)
       write(fp,'(1X,A)')str//": Scale factor out of range"
    case(IOERR_BAD_EXPONENT)
       write(fp,'(1X,A)')str//": Exponent too large for w.d format"
    case(IOERR_INPUT_BUFFER_OVERFLOW)
       write(fp,'(1X,A)')str//": Record too long for input buffer"
    case(IOERR_ZERO_REPEAT)
       write(fp,'(1X,A)')str//": Zero repeat factor in list-directed input"
    case(IOERR_BAD_INTEGER)
       write(fp,'(1X,A)')str//": Invalid input for integer editing"
    case(IOERR_INTEGER1_TOO_BIG)
       write(fp,'(1X,A)')str//": Input value too large for INTEGER(KIND=1)"
    case(IOERR_INTEGER2_TOO_BIG)
       write(fp,'(1X,A)')str//": Input value too large for INTEGER(KIND=2)"
    case(IOERR_INTEGER_OVERFLOW_REPEAT)
       write(fp,'(1X,A)')str//": Repeat factor in list-directed input larger than HUGE(0)"
    case(IOERR_INTEGER_TOO_BIG)
       write(fp,'(1X,A)')str//": Input value too large for default INTEGER type"
    case(IOERR_BAD_REAL)
       write(fp,'(1X,A)')str//": Invalid input for real editing"
    case(IOERR_BAD_LOGICAL)
       write(fp,'(1X,A)')str//": Invalid input for logical editing"
    case(IOERR_BAD_COMPLEX)
       write(fp,'(1X,A)')str//": Invalid input for complex editing"
    case(IOERR_BAD_CHAR)
       write(fp,'(1X,A)')str//": Invalid input for character editing"
    case(IOERR_FORMAT_NO_LPAREN)
       write(fp,'(1X,A)')str//": Format specification does not begin with a left parenthesis"
    case(IOERR_FORMAT_NO_ENDING_RPAREN)
       write(fp,'(1X,A)')str//": Format specification does not end with a right parenthesis"
    case(IOERR_NO_DATA_EDIT_IN_REVERSION)
       write(fp,'(1X,A)')str//": No data edit descriptor in tail of format specification after reversion"
    case(IOERR_SUBFMT_TOO_DEEP)
       write(fp,'(1X,A)')str//": Sub-format groups nested too deeply"
    case(IOERR_UNEXPECTED_FORMAT_END)
       write(fp,'(1X,A)')str//": Unexpected end of format specification"
    case(IOERR_EXPECTED_INTEGER_VALUE)
       write(fp,'(1X,A)')str//": Expected integer literal constant in format specification"
    case(IOERR_FORMAT_MBNZ)
       write(fp,'(1X,A)')str//": Field/exponent width or repeat in format specification must be non-zero"
    case(IOERR_EXPECTED_PERIOD)
       write(fp,'(1X,A)')str//": Expected decimal point in format specification"
    case(IOERR_EXPECTED_P)
       write(fp,'(1X,A)')str//": Expected P following signed integer constant in format specification"
    case(IOERR_BAD_BNBZ)
       write(fp,'(1X,A)')str//": Expected N or Z following B in format specification"
    case(IOERR_BAD_EDIT)
       write(fp,'(1X,A)')str//": Invalid edit descriptor"
    case(IOERR_NO_EDIT_FOR_REPEAT)
       write(fp,'(1X,A)')str//": No edit descriptor following repeat factor"
    case(IOERR_REPEAT_FOR_SIGN)
       write(fp,'(1X,A)')str//": Repeat factor given for sign edit descriptor"
    case(IOERR_REPEAT_FOR_BLANK_INTERP)
       write(fp,'(1X,A)')str//": Repeat factor given for blank-interpretation edit descriptor"
    case(IOERR_MISSING_HOLLERITH_LENGTH)
       write(fp,'(1X,A)')str//": Missing length of H edit descriptor"
    case(IOERR_REPEAT_FOR_CHAR_EDIT)
       write(fp,'(1X,A)')str//": Repeat factor given for character string edit descriptor"
    case(IOERR_NO_SPACING_FOR_X)
       write(fp,'(1X,A)')str//": No spacing specified for X edit descriptor"
    case(IOERR_REPEAT_FOR_POSITION)
       write(fp,'(1X,A)')str//": Repeat factor given for position edit descriptor"
    case(IOERR_CHAR_EDIT_IN_READ)
       write(fp,'(1X,A)')str//": Character string edit descriptor used on input"
    case(IOERR_BAD_EDIT_FOR_REAL)
       write(fp,'(1X,A)')str//": Invalid edit descriptor for real i/o-list item"
    case(IOERR_BAD_EDIT_FOR_INTEGER)
       write(fp,'(1X,A)')str//": Invalid edit descriptor for integer i/o-list item"
    case(IOERR_BAD_EDIT_FOR_LOGICAL)
       write(fp,'(1X,A)')str//": Invalid edit descriptor for logical i/o-list item"
    case(IOERR_CHAR_OVERLAPS_END)
       write(fp,'(1X,A)')str//": Character string edit descriptor does not terminate before format end"
    case(IOERR_ONLY_SIGN_FOUND)
       write(fp,'(1X,A)')str//": Sign in a numeric input field not followed by any digits"
    case(IOERR_BAD_INPUT_EXPONENT)
       write(fp,'(1X,A)')str//": Invalid exponent in real input field"
    case(IOERR_BAD_INPUT_REAL)
       write(fp,'(1X,A)')str//": Invalid character in real input field"
    case(IOERR_BAD_INPUT_INTEGER)
       write(fp,'(1X,A)')str//": Invalid character in integer input field"
    case(IOERR_BAD_BINARY)
       write(fp,'(1X,A)')str//": Invalid character in binary integer input field"
    case(IOERR_BAD_OCTAL)
       write(fp,'(1X,A)')str//": Invalid character in octal integer input field"
    case(IOERR_BAD_HEX)
       write(fp,'(1X,A)')str//": Invalid character in hexadecimal integer input field"
    case(IOERR_BAD_EDIT_FOR_CHARACTER)
       write(fp,'(1X,A)')str//": Invalid edit descriptor for character i/o-list item"
    case(IOERR_READ_AFTER_WRITE)
       write(fp,'(1X,A)')str//": READ after WRITE with no intervening file positioning"
    case(IOERR_BAD_UNIT)
       write(fp,'(1X,A)')str//": Unit number out of range"
    case(IOERR_NOT_CONNECTED)
       write(fp,'(1X,A)')str//": Unit is not connected"
    case(IOERR_CANNOT_BACKSPACE)
       write(fp,'(1X,A)')str//": File connected to unit is not capable of BACKSPACE"
    case(IOERR_NOT_SEQUENTIAL)
       write(fp,'(1X,A)')str//": Unit is not connected for SEQUENTIAL i/o"
    case(IOERR_NOT_READ)
       write(fp,'(1X,A)')str//": Unit is not connected for READ action"
    case(IOERR_NOT_FORMATTED)
       write(fp,'(1X,A)')str//": Unit is not connected for FORMATTED i/o"
    case(IOERR_NOT_WRITE)
       write(fp,'(1X,A)')str//": Unit is not connected for WRITE action"
    case(IOERR_NOT_UNFORMATTED)
       write(fp,'(1X,A)')str//": Unit is not connected for UNFORMATTED i/o"
    case(IOERR_NOT_CONNECTED_NO_FILENAME)
       write(fp,'(1X,A)')str//": Unit is not connected and no FILE= specifier on OPEN"
    case(IOERR_SCRATCH_NAMED)
       write(fp,'(1X,A)')str//": FILE= specifier on OPEN with STATUS='SCRATCH'"
    case(IOERR_DIFFERENT_STATUS)
       write(fp,'(1X,A)')str//": OPEN on connected unit has different STATUS= specifier"
    case(IOERR_DIFFERENT_ACCESS)
       write(fp,'(1X,A)')str//": OPEN on connected unit has different ACCESS= specifier"
    case(IOERR_DIFFERENT_FORM)
       write(fp,'(1X,A)')str//": OPEN on connected unit has different FORM= specifier"
    case(IOERR_DIFFERENT_RECL)
       write(fp,'(1X,A)')str//": OPEN on connected unit has different RECL= specifier"
    case(IOERR_DIFFERENT_ACTION)
       write(fp,'(1X,A)')str//": OPEN on connected unit has different ACTION= specifier"
    case(IOERR_DIFFERENT_POSITION)
       write(fp,'(1X,A)')str//": OPEN on connected unit has different POSITION= specifier"
    case(IOERR_BAD_STATUS)
       write(fp,'(1X,A)')str//": Invalid value for STATUS= specifier"
    case(IOERR_BAD_ACCESS)
       write(fp,'(1X,A)')str//": Invalid value for ACCESS= specifier"
    case(IOERR_BAD_FORM)
       write(fp,'(1X,A)')str//": Invalid value for FORM= specifier"
    case(IOERR_BAD_BLANKS)
       write(fp,'(1X,A)')str//": Invalid value for BLANKS= specifier"
    case(IOERR_BAD_POSITION)
       write(fp,'(1X,A)')str//": Invalid value for POSITION= specifier"
    case(IOERR_BAD_ACTION)
       write(fp,'(1X,A)')str//": INvalid value for ACTION= specifier"
    case(IOERR_BAD_DELIM)
       write(fp,'(1X,A)')str//": Invalid value for DELIM= specifier"
    case(IOERR_BAD_PAD)
       write(fp,'(1X,A)')str//": Invalid value for PAD= specifier"
    case(IOERR_NO_RECL)
       write(fp,'(1X,A)')str//": The RECL= specifier must be given for DIRECT access OPEN"
    case(IOERR_CANNOT_KEEP)
       write(fp,'(1X,A)')str//": STATUS='KEEP' is invalid for a SCRATCH file"
    case(IOERR_ENDFILE_TWICE)
       write(fp,'(1X,A)')str//": ENDFILE applied twice to unit with no intervening file positioning"
    case(IOERR_NAME_TOO_LONG)
       write(fp,'(1X,A)')str//": File name too long"
    case(IOERR_NO_OLD_FILE)
       write(fp,'(1X,A)')str//": Cannot find OLD file"
    case(IOERR_NEW_FILE_EXISTS)
       write(fp,'(1X,A)')str//": NeW file already exists"
    case(IOERR_CANNOT_REWIND)
       write(fp,'(1X,A)')str//": File connected to unit is not capable of REWIND"
    case(IOERR_BACKSPACE_FAILED)
       write(fp,'(1X,A)')str//": BACKSPACE failed to find the beginning of the previous record"
    case(IOERR_NOT_DIRECT)
       write(fp,'(1X,A)')str//": Unit is not connected for DIRECT i/o"
    case(IOERR_BAD_REC)
       write(fp,'(1X,A)')str//": Record number out of range"
    case(IOERR_BAD_INPUT_LOGICAL)
       write(fp,'(1X,A)')str//": Illegal character in LOGICAL input field"
    case(IOERR_NO_INPUT_LOGICAL)
       write(fp,'(1X,A)')str//": No value found in LOGICAL input field"
    case(IOERR_CANNOT_OPEN)
       write(fp,'(1X,A)')str//": Unknown OPEN failure on unit"
    case(IOERR_NO_AMPERSAND)
       write(fp,'(1X,A)')str//": Expected '&' but found '%c' in NAMELIST input"
    case(IOERR_GROUP_NAME_TOO_LONG)
       write(fp,'(1X,A)')str//": NAMELIST group name in input is too long"
    case(IOERR_WRONG_NAMELIST)
       write(fp,'(1X,A)')str//": Expected NAMELIST group /%s/ but found /%s/"
    case(IOERR_NAMELIST_BAD_CHAR)
       write(fp,'(1X,A)')str//": Invalid character '%c' in NAMELIST input"
    case(IOERR_OBJECT_NAME_TOO_LONG)
       write(fp,'(1X,A)')str//": NAMELIST group name in input of NAMELIST/%s/ is too long"
    case(IOERR_EXPECTED_EQUALS)
       write(fp,'(1X,A)')str//": Expected '=' but found '%c' in NAMELIST input"
    case(IOERR_UNKNOWN_OBJECT_NAME)
       write(fp,'(1X,A)')str//": Unknown group object \""%s\"" in input for NAMELIST/%s/"
    case(IOERR_UNEXPECTED_SUBSCRIPT)
       write(fp,'(1X,A)')str//": Unexpected subscript for object %s of NAMELIST/%s/"
    case(IOERR_UNEXPECTED_COMPONENT)
       write(fp,'(1X,A)')str//": Unexpected component specifier for object %s of NAMELIST/%s/"
    case(IOERR_COMPONENT_NAME_TOO_LONG)
       write(fp,'(1X,A)')str//": Component name too long in input for object %s of NAMELIST/%s/"
    case(IOERR_UNKNOWN_COMPONENT)
       write(fp,'(1X,A)')str//": Unknown component \""%s\"" in input for object %s of NAMELIST/%s/"
    case(IOERR_ARRAY_OF_ARRAY)
       write(fp,'(1X,A)')str//": Array component of array parent in input for object %s of NAMELIST/%s/"
    case(IOERR_BAD_INTEGER_LITERAL)
       write(fp,'(1X,A)')str//": Invalid integer literal in input for object %s of NAMELIST/%s/"
    case(IOERR_EXPECTED_COLON)
       write(fp,'(1X,A)')str//": Expected ':' but found '%c' in input for object %s of NAMELIST/%s/"
    case(IOERR_ZERO_LENGTH_INPUT)
       write(fp,'(1X,A)')str//": Substring has zero length in input for object %s of NAMELIST/%s/"
    case(IOERR_SUBSTRING_OUT_OF_BOUNDS)
       write(fp,'(1X,A)')str//": Substring (%d:%d) out of bounds in input for object %s of NAMELIST/%s/"
    case(IOERR_EXPECTED_COMMA)
       write(fp,'(1X,A)')str//": Expected ',' but found '%c' in input for object %s of NAMELIST/%s/"
    case(IOERR_EXPECTED_RPAREN)
       write(fp,'(1X,A)')str//": Expected ')' but found '%c' in input for object %s of NAMELIST/%s/"
    case(IOERR_SUBSCRIPT_OUT_OF_RANGE)
       write(fp,'(1X,A)')str//": Subscript (%d) out of range in input for object %s of NAMELIST/%s/"
    case(IOERR_ZERO_SIZE_INPUT)
       write(fp,'(1X,A)')str//": Array section has zero size in input for object %s of NAMELIST/%s/"
    case(IOERR_ZERO_STRIDE)
       write(fp,'(1X,A)')str//": Section stride has value zero in input for object %s of NAMELIST/%s/"
    case(IOERR_NO_NAMELIST_GROUP_NAME)
       write(fp,'(1X,A)')str//": Missing namelist group name in input of NAMELIST/%s/"
    case(IOERR_INPUT_LIST_TOO_BIG)
       write(fp,'(1X,A)')str//": Input list bigger than record length in unformatted READ on unit %d"
    case(IOERR_RECORD_TOO_SHORT)
       write(fp,'(1X,A)')str//": Record too short for format requirement and PAD='NO' on unit %d"
    case(IOERR_CORRUPT_UNFORMATTED_FILE)
       write(fp,'(1X,A)')str//": Unformatted data file open on unit %d is corrupt"
    case(IOERR_TRUNCATE_FAILED)
       write(fp,'(1X,A)')str//": File truncation on unit %d failed"
    case(IOERR_RW_AFTER_ENDFILE)
       write(fp,'(1X,A)')str//": READ/WRITE attempted after ENDFILE on unit %d"
    case(IOERR_INTEGER64_TOO_BIG)
       write(fp,'(1X,A)')str//": Input value too large for 64-bit integer"
    case(IOERR_NO_FILE_WITH_REPLACE)
       write(fp,'(1X,A)')str//": No FILE= specifier with STATUS='REPLACE'"
    case(IOERR_RECL_LE_ZERO)
       write(fp,'(1X,A)')str//": Invalid value for RECL= specifier (must be positive)"
    case(IOERR_END_OF_DIRECT_ACCESS)
       write(fp,'(1X,A)')str//": READ beyond end of direct access file on unit %d"
    case(IOERR_REAL_INPUT_OVERFLOW)
       write(fp,'(1X,A)')str//": Floating overflow on real number input"

! From /usr/src/linux-2.0.36/include/asm-i386/errno.h

    case(1)
       write(fp,'(1X,A)')str//":  Operation not permitted"
    case(2)
       write(fp,'(1X,A)')str//":  No such file or directory"
    case(3)
       write(fp,'(1X,A)')str//":  No such process"
    case(4)
       write(fp,'(1X,A)')str//":  Interrupted system call"
    case(5)
       write(fp,'(1X,A)')str//":  I/O error"
    case(6)
       write(fp,'(1X,A)')str//":  No such device or address"
    case(7)
       write(fp,'(1X,A)')str//":  Arg list too long"
    case(8)
       write(fp,'(1X,A)')str//":  Exec format error"
    case(9)
       write(fp,'(1X,A)')str//":  Bad file number"
    case(10)
       write(fp,'(1X,A)')str//":  No child processes"
    case(11)
       write(fp,'(1X,A)')str//":  Try again"
    case(12)
       write(fp,'(1X,A)')str//":  Out of memory"
    case(13)
       write(fp,'(1X,A)')str//":  Permission denied"
    case(14)
       write(fp,'(1X,A)')str//":  Bad address"
    case(15)
       write(fp,'(1X,A)')str//":  Block device required"
    case(16)
       write(fp,'(1X,A)')str//":  Device or resource busy"
    case(17)
       write(fp,'(1X,A)')str//":  File exists"
    case(18)
       write(fp,'(1X,A)')str//":  Cross-device link"
    case(19)
       write(fp,'(1X,A)')str//":  No such device"
    case(20)
       write(fp,'(1X,A)')str//":  Not a directory"
    case(21)
       write(fp,'(1X,A)')str//":  Is a directory"
    case(22)
       write(fp,'(1X,A)')str//":  Invalid argument"
    case(23)
       write(fp,'(1X,A)')str//":  File table overflow"
    case(24)
       write(fp,'(1X,A)')str//":  Too many open files"
    case(25)
       write(fp,'(1X,A)')str//":  Not a typewriter"
    case(26)
       write(fp,'(1X,A)')str//":  Text file busy"
    case(27)
       write(fp,'(1X,A)')str//":  File too large"
    case(28)
       write(fp,'(1X,A)')str//":  No space left on device"
    case(29)
       write(fp,'(1X,A)')str//":  Illegal seek"
    case(30)
       write(fp,'(1X,A)')str//":  Read-only file system"
    case(31)
       write(fp,'(1X,A)')str//":  Too many links"
    case(32)
       write(fp,'(1X,A)')str//":  Broken pipe"
    case(33)
       write(fp,'(1X,A)')str//":  Math argument out of domain of func"
    case(34)
       write(fp,'(1X,A)')str//":  Math result not representable"
    case(35)
       write(fp,'(1X,A)')str//":  Resource deadlock would occur"
    case(36)
       write(fp,'(1X,A)')str//":  File name too long"
    case(37)
       write(fp,'(1X,A)')str//":  No record locks available"
    case(38)
       write(fp,'(1X,A)')str//":  Function not implemented"
    case(39)
       write(fp,'(1X,A)')str//":  Directory not empty"
    case(40)
       write(fp,'(1X,A)')str//":  Too many symbolic links encountered"

    case(42)
       write(fp,'(1X,A)')str//":  No message of desired type"
    case(43)
       write(fp,'(1X,A)')str//":  Identifier removed"
    case(44)
       write(fp,'(1X,A)')str//":  Channel number out of range"
    case(45)
       write(fp,'(1X,A)')str//":  Level 2 not synchronized"
    case(46)
       write(fp,'(1X,A)')str//":  Level 3 halted"
    case(47)
       write(fp,'(1X,A)')str//":  Level 3 reset"
    case(48)
       write(fp,'(1X,A)')str//":  Link number out of range"
    case(49)
       write(fp,'(1X,A)')str//":  Protocol driver not attached"
    case(50)
       write(fp,'(1X,A)')str//":  No CSI structure available"
    case(51)
       write(fp,'(1X,A)')str//":  Level 2 halted"
    case(52)
       write(fp,'(1X,A)')str//":  Invalid exchange"
    case(53)
       write(fp,'(1X,A)')str//":  Invalid request descriptor"
    case(54)
       write(fp,'(1X,A)')str//":  Exchange full"
    case(55)
       write(fp,'(1X,A)')str//":  No anode"
    case(56)
       write(fp,'(1X,A)')str//":  Invalid request code"
    case(57)
       write(fp,'(1X,A)')str//":  Invalid slot"

    case(59)
       write(fp,'(1X,A)')str//":  Bad font file format"
    case(60)
       write(fp,'(1X,A)')str//":  Device not a stream"
    case(61)
       write(fp,'(1X,A)')str//":  No data available"
    case(62)
       write(fp,'(1X,A)')str//":  Timer expired"
    case(63)
       write(fp,'(1X,A)')str//":  Out of streams resources"
    case(64)
       write(fp,'(1X,A)')str//":  Machine is not on the network"
    case(65)
       write(fp,'(1X,A)')str//":  Package not installed"
    case(66)
       write(fp,'(1X,A)')str//":  Object is remote"
    case(67)
       write(fp,'(1X,A)')str//":  Link has been severed"
    case(68)
       write(fp,'(1X,A)')str//":  Advertise error"
    case(69)
       write(fp,'(1X,A)')str//":  Srmount error"
    case(70)
       write(fp,'(1X,A)')str//":  Communication error on send"
    case(71)
       write(fp,'(1X,A)')str//":  Protocol error"
    case(72)
       write(fp,'(1X,A)')str//":  Multihop attempted"
    case(73)
       write(fp,'(1X,A)')str//":  RFS specific error"
    case(74)
       write(fp,'(1X,A)')str//":  Not a data message"
    case(75)
       write(fp,'(1X,A)')str//":  Value too large for defined data type"
    case(76)
       write(fp,'(1X,A)')str//":  Name not unique on network"
    case(77)
       write(fp,'(1X,A)')str//":  File descriptor in bad state"
    case(78)
       write(fp,'(1X,A)')str//":  Remote address changed"
    case(79)
       write(fp,'(1X,A)')str//":  Can not access a needed shared library"
    case(80)
       write(fp,'(1X,A)')str//":  Accessing a corrupted shared library"
    case(81)
       write(fp,'(1X,A)')str//":  .lib section in a.out corrupted"
    case(82)
       write(fp,'(1X,A)')str//":  Attempting to link in too many shared libraries"
    case(83)
       write(fp,'(1X,A)')str//":  Cannot exec a shared library directly"
    case(84)
       write(fp,'(1X,A)')str//":  Illegal byte sequence"
    case(85)
       write(fp,'(1X,A)')str//":  Interrupted system call should be restarted"
    case(86)
       write(fp,'(1X,A)')str//":  Streams pipe error"
    case(87)
       write(fp,'(1X,A)')str//":  Too many users"
    case(88)
       write(fp,'(1X,A)')str//":  Socket operation on non-socket"
    case(89)
       write(fp,'(1X,A)')str//":  Destination address required"
    case(90)
       write(fp,'(1X,A)')str//":  Message too long"
    case(91)
       write(fp,'(1X,A)')str//":  Protocol wrong type for socket"
    case(92)
       write(fp,'(1X,A)')str//":  Protocol not available"
    case(93)
       write(fp,'(1X,A)')str//":  Protocol not supported"
    case(94)
       write(fp,'(1X,A)')str//":  Socket type not supported"
    case(95)
       write(fp,'(1X,A)')str//":  Operation not supported on transport endpoint"
    case(96)
       write(fp,'(1X,A)')str//":  Protocol family not supported"
    case(97)
       write(fp,'(1X,A)')str//":  Address family not supported by protocol"
    case(98)
       write(fp,'(1X,A)')str//":  Address already in use"
    case(99)
       write(fp,'(1X,A)')str//":  Cannot assign requested address"
!!$ case(100)
!!$ write(fp,'(1X,A)')str//":  Network is down"
!!$ case(101)
!!$ write(fp,'(1X,A)')str//":  Network is unreachable"
!!$ case(102)
!!$ write(fp,'(1X,A)')str//":  Network dropped connection because of reset"
!!$ case(103)
!!$ write(fp,'(1X,A)')str//":  Software caused connection abort"
!!$ case(104)
!!$ write(fp,'(1X,A)')str//":  Connection reset by peer"
!!$ case(105)
!!$ write(fp,'(1X,A)')str//":  No buffer space available"
!!$ case(106)
!!$ write(fp,'(1X,A)')str//":  Transport endpoint is already connected"
!!$ case(107)
!!$ write(fp,'(1X,A)')str//":  Transport endpoint is not connected"
!!$ case(108)
!!$ write(fp,'(1X,A)')str//":  Cannot send after transport endpoint shutdown"
!!$ case(109)
!!$ write(fp,'(1X,A)')str//":  Too many references: cannot splice"
!!$ case(110)
!!$ write(fp,'(1X,A)')str//":  Connection timed out"
!!$ case(111)
!!$ write(fp,'(1X,A)')str//":  Connection refused"
!!$ case(112)
!!$ write(fp,'(1X,A)')str//":  Host is down"
!!$ case(113)
!!$ write(fp,'(1X,A)')str//":  No route to host"
!!$ case(114)
!!$ write(fp,'(1X,A)')str//":  Operation already in progress"
!!$ case(115)
!!$ write(fp,'(1X,A)')str//":  Operation now in progress"
!!$ case(116)
!!$ write(fp,'(1X,A)')str//":  Stale NFS file handle"
!!$ case(117)
!!$ write(fp,'(1X,A)')str//":  Structure needs cleaning"
!!$ case(118)
!!$ write(fp,'(1X,A)')str//":  Not a XENIX named type file"
!!$ case(119)
!!$ write(fp,'(1X,A)')str//":  No XENIX semaphores available"
!!$ case(120)
!!$ write(fp,'(1X,A)')str//":  Is a named type file"
!!$ case(121)
!!$ write(fp,'(1X,A)')str//":  Remote I/O error"
!!$ case(122)
!!$ write(fp,'(1X,A)')str//":  Quota exceeded"
!!$
!!$ case(123)
!!$ write(fp,'(1X,A)')str//":  No medium found"
!!$  case(124)
!!$  write(fp,'(1X,A)')str//":  Wrong medium type"
    case default
       write(fp,'(1X,A,I4)')str//": Unknown error number iostat=",iostat
    end select
  end subroutine print_iostat
end module nag_iostat
