module pro_state_f90_def
  use vector
  use matrix
  implicit none
  !private SR2201BUG  

  public :: reduce   ! Overloaded function
  type, public ::  pro_state_t
     integer :: num_p        ! number of particles
     real(r_kind) :: load    ! percentage of processor load 1.= no free time
     real(r_kind) :: g_mem   ! how much memory the grid has used
     type(rreg_t) :: region  ! The region of the particles we have
     type(rvec_t)  :: r_mean  ! The mean particle position
     type(rvec_t)  :: v_mean  ! The mean velocity
     type(rmat_t)  :: r_sqr   ! Inertia matrix
    ! Possibly add intertia matrix
  end type pro_state_t
  interface reduce
     module procedure reduce_pro_state
  end interface
contains
  ! reduce an array of processor states to a single item
  ! by sum, min etc at appropriate
  function reduce_pro_state(a) result (r)
    type(pro_state_t), intent(in) :: a(:)
    type(pro_state_t) r
    r%num_p = sum(a%num_p)
    r%load = sum(a%load)
    r%g_mem = sum(a%g_mem)
    r%region = union(a%region)
    r%r_mean = sum(a%r_mean*a%num_p)/r%num_p
    r%v_mean = sum(a%v_mean*a%num_p)/r%num_p
    r%r_sqr = sum(a%r_sqr*a%num_p)/r%num_p
  end function reduce_pro_state
end module pro_state_f90_def
