module rec_flags_mpi_def
  use rec_flags_f90_def, only:  rec_flags_t
  use user_rec_flags_s
  use mpi_main
contains
  subroutine init_rec_flags_mpi_def  
    !  implicit none
    type(rec_flags_t) :: d(2)
    type(mpi_datatype_t) :: datatype
    type(mpi_address_t)  addr1, addr2
    datatype = fmpi_get_datatype(d(1))
    if (datatype/=fmpi_rec_flags_t) then
       print('mpi datatypes do not match up in definition of rec_flags_t')
       call mpi_abort(666)
    end if
    
    call fmpi_address(d(1),addr1)  
    call fmpi_address(d(2),addr2)
    call fmpi_type_contiguous(addr2-addr1,FMPI_BYTE,fmpi_rec_flags_t)
    call fmpi_type_commit(fmpi_rec_flags_t)
  end subroutine init_rec_flags_mpi_def
end module rec_flags_mpi_def
