module rmat_mpi_def
  use rmat_f90_def, only:  rmat_t
  use user_rmat_s
  use mpi_main
contains
  subroutine init_rmat_mpi_def  
    !  implicit none
    type(rmat_t) :: d(2)
    type(mpi_datatype_t) :: datatype
    type(mpi_address_t)  addr1, addr2
    datatype = fmpi_get_datatype(d(1))
    if (datatype/=fmpi_rmat_t) then
       print('mpi datatypes do not match up in definition of rmat_t')
       call mpi_abort(666)
    end if
    
    call fmpi_address(d(1),addr1)  
    call fmpi_address(d(2),addr2)
    call fmpi_type_contiguous(addr2-addr1,FMPI_BYTE,fmpi_rmat_t)
    call fmpi_type_commit(fmpi_rmat_t)
  end subroutine init_rmat_mpi_def
end module rmat_mpi_def
