# 1 "rvec_and_rang.F90"
# 1 "/home/jim/fortran/library/dimension.h" 1 
!Define preprocessor macros that define the dimension
!Default is Three dimensions
!Overide by compiling with -DTWODIM or defining 1 before this is included
!If the file is directly edited then the dependencies will cause the correct files
!to be recompiled so this is probably best
 
# 11


! Commands only for three dimensions use the macro CMD3() 








! Commands only for two dimensions use the macro 
# 28



# 2 "/home/jim/fortran/library/rvec_and_rang.F90" 2 
! Module containing function that connect vectors and chains (angular velocities)
! Since chains are rotations also has function for converting
! chains to and from rotation matrices
! and implimentation approach for chains would be directly in terms of
! rotation matrices but this is unnecessary 
! if we're only considering 2d and 3d systems 
module rvec_and_rang
  use rvec_f90_def  
  use rang_f90_def
  use rmat_f90_def

  interface operator(.x.)  ! Comibine vectors and chains
     module procedure cross_rvec_rang, cross_rang_rvec, cross_rvec_rvec, &
          cross_arvec_arang, cross_arang_arvec, cross_arvec_arvec, &
          cross_rvec_arang, cross_rang_arvec, cross_rvec_arvec, &
          cross_arvec_rang, cross_arang_rvec, cross_arvec_rvec 
  end interface
  interface operator(*)
     module procedure &
          rmat_mult_rang, rmat_mult_arang
  end interface
 
  interface rotate_matrix  ! Convert a chain to a rotation matrix
     module procedure rotate_matrix
  end interface

  interface rotate         ! Rotate a vector by a chain
     module procedure rotate_ssrvec, rotate_sarvec, rotate_asrvec, rotate_aarvec
  end interface

contains
  function cross_rvec_rvec(a,b) result(r)
    type(rvec_t) , intent(in) :: a
    type(rvec_t) , intent(in) :: b
    type(rang_t) r
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_rvec_rvec
  function cross_rvec_rang(a,b) result(r)
    type(rvec_t), intent(in) :: a
    type(rang_t), intent(in) :: b
    type(rvec_t) r
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_rvec_rang
  function cross_rang_rvec(a,b) result(r)
    type(rang_t), intent(in) :: a
    type(rvec_t), intent(in) :: b
    type(rvec_t) r
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_rang_rvec

  function cross_arvec_arvec(a,b) result(r)
    type(rvec_t) , intent(in) :: a(:)
    type(rvec_t) , intent(in) :: b(size(a))
    type(rang_t) r(size(a))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_arvec_arvec
  function cross_arvec_arang(a,b) result(r)
    type(rvec_t), intent(in) :: a(:)
    type(rang_t), intent(in) :: b(size(a))
    type(rvec_t) r(size(a))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_arvec_arang
  function cross_arang_arvec(a,b) result(r)
    type(rang_t), intent(in) :: a(:)
    type(rvec_t), intent(in) :: b(size(a))
    type(rvec_t) r(size(a))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_arang_arvec

  function cross_rvec_arvec(a,b) result(r)
    type(rvec_t) , intent(in) :: a
    type(rvec_t) , intent(in) :: b(:)
    type(rang_t) r(size(b))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_rvec_arvec
  function cross_rvec_arang(a,b) result(r)
    type(rvec_t), intent(in) :: a
    type(rang_t), intent(in) :: b(:)
    type(rvec_t) r(size(b))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_rvec_arang
  function cross_rang_arvec(a,b) result(r)
    type(rang_t), intent(in) :: a
    type(rvec_t), intent(in) :: b(:)
    type(rvec_t) r(size(b))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_rang_arvec

  function cross_arvec_rvec(a,b) result(r)
    type(rvec_t) , intent(in) :: a(:)
    type(rvec_t) , intent(in) :: b
    type(rang_t) r(size(a))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_arvec_rvec
  function cross_arvec_rang(a,b) result(r)
    type(rvec_t), intent(in) :: a(:)
    type(rang_t), intent(in) :: b
    type(rvec_t) r(size(a))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_arvec_rang
  function cross_arang_rvec(a,b) result(r)
    type(rang_t), intent(in) :: a(:)
    type(rvec_t), intent(in) :: b
    type(rvec_t) r(size(a))
    r%x=a%y*b%z-b%y*a%z;r%y=a%z*b%x-b%z*a%x;r%z=a%x*b%y-b%x*a%y
    
  end function cross_arang_rvec

! return a rotation matrix
! a matrix for a rotation of |w| radians about w is created
  function rotate_matrix(w) result(m)
    type(rang_t), intent(in) :: w
    type(rmat_t) m
    real(r_kind) cos_theta, sin_theta
# 131


    type(rang_t) nw
    real(r_kind) theta
    theta = length(w)
    if (theta == 0) then
       m = real(1,r_kind) ! Return unit matrix
       return ! no rotation
    end if
    cos_theta = cos(theta)
    sin_theta = sin(theta)
    nw = w/theta
    m = rvec_t_cross(nw*sin_theta) + rang_mult_rang((1-cos_theta)*nw,nw))+ cos_theta

  end function rotate_matrix
  function rang_mult_rang(a,b) result(m)
    type(rang_t), intent(in) :: a,b
    type(rmat_t) m
    m%x = rvec_t(a%x*b%x, a%y*b%x, a%z*b%x)
    m%y = rvec_t(  m%x%y, a%y*b%y, a%z*b%y)
    m%z = rvec_t(  m%x%z, m%y%z,   a%z*b%z)
    
  end function rang_mult_rang

! return the matrix w.x.
  function rvec_t_cross(w) result(m)
    type(rang_t), intent(in) :: w
    type(rmat_t) m
    m%x = rvec_t(0,w%z,-w%y)
    m%y = rvec_t(-w%z,0,w%x) 
    m%z = rvec_t( w%y, -w%x,    0) 
  end function rvec_t_cross  
! What does this really mean ?
  function rmat_mult_rang(a,b) result(r)
    type(rmat_t), intent(in):: a
    type(rang_t), intent(in):: b
    type(rang_t)  r
    r%x = a%x%x * b%x + a%y%x * b%y + a%z%x * b%z
    r%y = a%x%y * b%x + a%y%y * b%y + a%z%y * b%z
    r%z = a%x%z * b%x + a%y%z * b%y + a%z%z * b%z
    
  end function rmat_mult_rang
  function rmat_mult_arang(a,b) result(r)
    type(rmat_t), intent(in):: a
    type(rang_t), intent(in):: b(:)
    type(rang_t)  r(size(b))
    r%x = a%x%x * b%x + a%y%x * b%y + a%z%x * b%z
    r%y = a%x%y * b%x + a%y%y * b%y + a%z%y * b%z
    r%z = a%x%z * b%x + a%y%z * b%y + a%z%z * b%z
    
  end function rmat_mult_arang

! Rotation angle is length of w in radians
  function rotate_ssrvec(w,v) result(r)
    type(rang_t), intent(in) :: w
    type(rvec_t), intent(in) :: v
    type(rvec_t) r
# 194


    real(r_kind) sin_theta, cos_theta, l
    l = length(w)
    sin_theta = sin(l)
    cos_theta = sqrt(1-sin_theta**2)
    r = cos_theta * v + sin_theta/l * (w.x.v) + (1-cos_theta)/l**2 * ( w.x. (w.x.v))

  end function rotate_ssrvec
  function rotate_sarvec(w,v) result(r)
    type(rang_t), intent(in) :: w
    type(rvec_t), intent(in) :: v(:)
    type(rvec_t) r(size(v))
# 213


    real(r_kind) sin_theta, cos_theta, l
    l = length(w)
    sin_theta = sin(l)
    cos_theta = cos(l)
    r = cos_theta * v + sin_theta/l * (w.x.v) + (1-cos_theta)/l**2 * ( w.x. (w.x.v))

  end function rotate_sarvec
  function rotate_asrvec(w,v) result(r)
    type(rang_t), intent(in) :: w(:)
    type(rvec_t), intent(in) :: v 
    type(rvec_t) r(size(w))
# 232


    real(r_kind) sin_theta(size(w)), cos_theta(size(w)), l(size(w))
    l = length(w)
    sin_theta = sin(l)
    cos_theta = cos(l)
    r = cos_theta * v + sin_theta/l * (w.x.v) + (1-cos_theta)/l**2 * ( w.x. (w.x.v))

  end function rotate_asrvec
  function rotate_aarvec(w,v) result(r)
    type(rang_t), intent(in) :: w(:)
    type(rvec_t), intent(in) :: v(size(w)) 
    type(rvec_t) r(size(v))
# 251


    real(r_kind) sin_theta(size(w)), cos_theta(size(w)), l(size(w))
    l = length(w)
    sin_theta = sin(l)
    cos_theta = cos(l)
    r = cos_theta * v + sin_theta/l * (w.x.v) + (1-cos_theta)/l**2 * ( w.x. (w.x.v))

  end function rotate_aarvec

end module rvec_and_rang
