module rvec_mpi_def
  use rvec_f90_def, only:  rvec_t
  use user_rvec_s
  use mpi_main
contains
  subroutine init_rvec_mpi_def  
    !  implicit none
    type(rvec_t) :: d(2)
    type(mpi_datatype_t) :: datatype
    type(mpi_address_t)  addr1, addr2
    datatype = fmpi_get_datatype(d(1))
    if (datatype/=fmpi_rvec_t) then
       print('mpi datatypes do not match up in definition of rvec_t')
       call mpi_abort(666)
    end if
    
    call fmpi_address(d(1),addr1)  
    call fmpi_address(d(2),addr2)
    call fmpi_type_contiguous(addr2-addr1,FMPI_BYTE,fmpi_rvec_t)
    call fmpi_type_commit(fmpi_rvec_t)
  end subroutine init_rvec_mpi_def
end module rvec_mpi_def
