module user_col_props_a
  use col_props_f90_def
  use mpi_include
  use mpi_typedefs
  use user_col_props_s
  !  There are various sorts of name replacements to think of
  !  Fortran types              type(col_props_t)
  !  Mpi types                  fmpi_col_props_t
  !  module and function names  _col_props
  !  also need to think about how to use this for multidimensional arrays
  !
  !       michael hennecke
  !       a fortran 90 interface to mpi version 1.1
  !       rz uni karlsruhe, internal report 63/96
  !
  !         auxiliary module template fmpi_col_props_t_a
  !
  !         03-oct-1996, hennecke@rz.uni-karlsruhe.de (v0.9c beta)
  !
  !       permission is granted to copy and distribute this file
  !       or modified versions of this file for no fee, provided the 
  !       copyright notice and this permission notice are preserved 
  !       on all copies.
  !
  !       (c) 1996  michael hennecke, rz universitaet karlsruhe
  !
  !       This is the file for scalar choice arguments
  ! this is designed so that it will compile as is or can have types changed using sed

  implicit none
  !private


  ! Special function returns the mpi datatype of an argument
  public :: fmpi_get_datatype
  interface fmpi_get_datatype
     module procedure mpi_get_datatype_col_props_a
  end interface

  public :: fmpi_get_count
  interface fmpi_get_count
     module procedure mpi_get_count_col_props_a
  end interface ! mpi_get_count


  !       ... a.9  fortran bindings for point-to-point communication  ...

  public :: fmpi_send
  interface fmpi_send
     module procedure mpi_send_col_props_a
  end interface ! mpi_send

  public :: fmpi_recv
  interface fmpi_recv
     module procedure mpi_recv_col_props_a
  end interface ! mpi_recv

  public :: fmpi_bsend
  interface fmpi_bsend
     module procedure mpi_bsend_col_props_a
  end interface ! mpi_bsend

  public :: fmpi_ssend
  interface fmpi_ssend
     module procedure mpi_ssend_col_props_a
  end interface ! mpi_ssend

  public :: fmpi_rsend
  interface fmpi_rsend
     module procedure mpi_rsend_col_props_a
  end interface ! mpi_rsend

  public :: fmpi_buffer_attach
  interface fmpi_buffer_attach
     module procedure mpi_buffer_attach_col_props_a
  end interface ! mpi_buffer_attach

  public :: fmpi_buffer_detach
  interface fmpi_buffer_detach
     module procedure mpi_buffer_detach_col_props_a
  end interface ! mpi_buffer_detach

  public :: fmpi_isend
  interface fmpi_isend
     module procedure mpi_isend_col_props_a
  end interface ! mpi_isend

  public :: fmpi_ibsend
  interface fmpi_ibsend
     module procedure mpi_ibsend_col_props_a
  end interface ! mpi_ibsend

  public :: fmpi_issend
  interface fmpi_issend
     module procedure mpi_issend_col_props_a
  end interface ! mpi_issend

  public :: fmpi_irsend
  interface fmpi_irsend
     module procedure mpi_irsend_col_props_a
  end interface ! mpi_irsend

  public :: fmpi_irecv
  interface fmpi_irecv
     module procedure mpi_irecv_col_props_a
  end interface ! mpi_irecv

  public :: fmpi_send_init
  interface fmpi_send_init
     module procedure mpi_send_init_col_props_a
  end interface ! mpi_send_init

  public :: fmpi_bsend_init
  interface fmpi_bsend_init
     module procedure mpi_bsend_init_col_props_a
  end interface ! mpi_bsend_init

  public :: fmpi_ssend_init
  interface fmpi_ssend_init
     module procedure mpi_ssend_init_col_props_a
  end interface ! mpi_ssend_init

  public :: fmpi_rsend_init
  interface fmpi_rsend_init
     module procedure mpi_rsend_init_col_props_a
  end interface ! mpi_rsend_init

  public :: fmpi_recv_init
  interface fmpi_recv_init
     module procedure mpi_recv_init_col_props_a
  end interface ! mpi_recv_init

  public :: fmpi_sendrecv
  interface fmpi_sendrecv
     module procedure mpi_sendrecv_col_props_a
  end interface ! mpi_sendrecv

  ! This internal name is changed so it doesn't get too long
  public :: fmpi_sendrecv_replace
  interface fmpi_sendrecv_replace
     module procedure mpi_sendrecv_r_col_props_a
  end interface ! mpi_sendrecv_replace

  public :: fmpi_address
  interface fmpi_address
     module procedure mpi_address_col_props_a
  end interface ! mpi_address

  public :: fmpi_pack
  interface fmpi_pack
     module procedure mpi_pack_col_props_a
  end interface ! mpi_pack

  public :: fmpi_unpack
  interface fmpi_unpack
     module procedure mpi_unpack_col_props_a
  end interface ! mpi_unpack

  !       ... a.10  fortran bindings for collective communication  ...

  public :: fmpi_bcast
  interface fmpi_bcast
     module procedure mpi_bcast_col_props_a
  end interface ! mpi_bcast

  public :: fmpi_gather        
  interface fmpi_gather
     module procedure mpi_gather_col_props_a
  end interface ! mpi_gather

  public :: fmpi_gatherv
  interface fmpi_gatherv
     module procedure mpi_gatherv_col_props_a
  end interface ! mpi_gatherv

  public :: fmpi_gathera
  interface fmpi_gathera
     module procedure mpi_gathera_col_props_a
  end interface ! mpi_gathera

  public :: fmpi_scatter
  interface fmpi_scatter
     module procedure mpi_scatter_col_props_a
  end interface ! mpi_scatter

  public :: fmpi_scatterv
  interface fmpi_scatterv
     module procedure mpi_scatterv_col_props_a
  end interface ! mpi_scatterv

  public :: fmpi_allgather
  interface fmpi_allgather
     module procedure mpi_allgather_col_props_a
  end interface ! mpi_allgather

  public :: fmpi_allgatherv
  interface fmpi_allgatherv
     module procedure mpi_allgatherv_col_props_a
  end interface ! mpi_allgatherv

  public :: fmpi_alltoall
  interface fmpi_alltoall
     module procedure mpi_alltoall_col_props_a
  end interface ! mpi_alltoall

  public :: fmpi_alltoallv
  interface fmpi_alltoallv
     module procedure mpi_alltoallv_col_props_a
  end interface ! mpi_alltoallv

  public :: fmpi_reduce
  interface fmpi_reduce
     module procedure mpi_reduce_col_props_a
  end interface ! mpi_reduce

  public :: fmpi_allreduce
  interface fmpi_allreduce
     module procedure mpi_allreduce_col_props_a
  end interface ! mpi_allreduce

  public :: fmpi_reduce_scatter
  interface fmpi_reduce_scatter
     module procedure mpi_reduce_scatter_col_props_a
  end interface ! mpi_reduce_scatter

  public :: fmpi_scan
  interface fmpi_scan
     module procedure mpi_scan_col_props_a
  end interface ! mpi_scan

contains
  ! Special function returns the mpi datatype of an argument
  function mpi_get_datatype_col_props_a(buf)
    type(col_props_t), intent(in)  :: buf(:)
    type(mpi_datatype_t) :: mpi_get_datatype_col_props_a
    mpi_get_datatype_col_props_a = fmpi_col_props_t
   end function mpi_get_datatype_col_props_a

  ! MPI functions
  subroutine mpi_get_count_col_props_a(status, buf, count, ierror)
    type(mpi_status_t), intent(in)  :: status
    type(col_props_t), intent(in)  :: buf(:)
    integer, intent(out) :: count
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o
    external mpi_get_count
    call mpi_get_count(status, fmpi_col_props_t, count, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_get_count_col_props_a


  ! Size(Buf) and fmpi_col_props_t are never specified
  !       ... a.9  fortran bindings for point-to-point communication  ...
  ! Section 2.2
  ! Blocking send p. 18 
  subroutine mpi_send_col_props_a(buf, dest, tag, comm, ierror)
    type(col_props_t), intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_send
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_send(buf, size(buf), fmpi_col_props_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_send_col_props_a

  ! Blocking receieve p. 22
  subroutine mpi_recv_col_props_a(buf, source, tag, status, comm, ierror)
    type(col_props_t), intent(out) :: buf(:)
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_status_t), intent(out), optional :: status
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    type(mpi_status_t) :: status_o
    external mpi_recv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call mpi_recv(buf, size(buf), fmpi_col_props_t, source, tag, comm_o, status_o, ierror_o)
    if (present(status)) status = status_o
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_recv_col_props_a

  subroutine mpi_bsend_col_props_a(buf, dest, tag, comm, ierror)
    type(col_props_t), intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_bsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call     mpi_bsend(buf, size(buf), fmpi_col_props_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_bsend_col_props_a

  subroutine mpi_ssend_col_props_a(buf, dest, tag, comm, ierror)
    type(col_props_t), intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_ssend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call     mpi_ssend(buf, size(buf), fmpi_col_props_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_ssend_col_props_a

  subroutine mpi_rsend_col_props_a(buf, dest, tag, comm, ierror)
    type(col_props_t), intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_rsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call     mpi_rsend(buf, size(buf), fmpi_col_props_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_rsend_col_props_a

  subroutine mpi_buffer_attach_col_props_a(buf, ierror)
    type(col_props_t), intent(in)  :: buf(:)
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_buffer_attach
    call     mpi_buffer_attach(buf, size(buf), ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_buffer_attach_col_props_a

  subroutine mpi_buffer_detach_col_props_a(buf, ierror)
    type(col_props_t), intent(out) :: buf(:)
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_buffer_detach
    call     mpi_buffer_detach(buf, size(buf), ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_buffer_detach_col_props_a

  ! immediate send p. 51
  subroutine mpi_isend_col_props_a(buf, dest, tag,  request, comm, ierror)
    type(col_props_t), target, intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_isend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_isend(buf(1), size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_isend_col_props_a

  subroutine mpi_ibsend_col_props_a(buf, dest, tag, request, comm, ierror)
    type(col_props_t), intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_ibsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_ibsend(buf, size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_ibsend_col_props_a

  subroutine mpi_issend_col_props_a(buf, dest, tag, request, comm, ierror)
    type(col_props_t), target, intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_issend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_issend(buf(1), size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_issend_col_props_a

  subroutine mpi_irsend_col_props_a(buf, dest, tag, request, comm, ierror)
    type(col_props_t), target, intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_irsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_irsend(buf(1), size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_irsend_col_props_a

  ! p. 51
  subroutine mpi_irecv_col_props_a(buf, source, tag, request, comm, ierror)
    type(col_props_t), target, intent(out) :: buf(:)
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_irecv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_irecv(buf(1), size(buf), fmpi_col_props_t, source, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_irecv_col_props_a

  subroutine mpi_send_init_col_props_a(buf, dest, tag, request, comm, ierror)
    type(col_props_t), target, intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_send_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_send_init(buf(1), size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_send_init_col_props_a

  subroutine mpi_bsend_init_col_props_a(buf, dest, tag, request, comm, ierror)
    type(col_props_t), target, intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_bsend_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_bsend_init(buf(1), size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_bsend_init_col_props_a

  subroutine mpi_ssend_init_col_props_a(buf, dest, tag, request, comm, ierror)
    type(col_props_t), target, intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_ssend_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_ssend_init(buf(1), size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_ssend_init_col_props_a

  subroutine mpi_rsend_init_col_props_a(buf, dest, tag, request, comm, ierror)
    type(col_props_t), target, intent(in)  :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_rsend_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_rsend_init(buf(1), size(buf), fmpi_col_props_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_rsend_init_col_props_a

  subroutine mpi_recv_init_col_props_a(buf,  source, tag, request, comm, ierror)
    type(col_props_t), target, intent(out) :: buf(:)
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_recv_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_recv_init(buf(1), size(buf), fmpi_col_props_t, source, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_recv_init_col_props_a

  ! This is fixed to send and recieve are the same type and 
  subroutine mpi_sendrecv_col_props_a(sendbuf, dest, sendtag, &
       recvbuf,  source, recvtag, status, comm, ierror)
    type(col_props_t), intent(in)  :: sendbuf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: sendtag
    type(col_props_t), intent(out) :: recvbuf(size(sendbuf))
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: recvtag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_status_t), intent(out), optional :: status
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_status_t) :: status_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_sendrecv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_sendrecv(sendbuf, size(sendbuf), fmpi_col_props_t, dest, sendtag, recvbuf, &
         &      size(recvbuf), fmpi_col_props_t, source, recvtag, comm_o, status_o,  ierror_o)
    if (present(ierror)) ierror = ierror_o
    if (present(status)) status = status_o
  end subroutine mpi_sendrecv_col_props_a


  subroutine mpi_sendrecv_r_col_props_a(buf, dest, sendtag, source, recvtag, status, comm,ierror)
    type(col_props_t), intent(inout) :: buf(:)
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: sendtag
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: recvtag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_status_t), intent(out), optional :: status
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_status_t) :: status_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_sendrecv_replace
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_sendrecv_replace(buf, size(buf), fmpi_col_props_t, dest, sendtag, source, recvtag,comm_o, status_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
    if (present(status)) status = status_o
  end subroutine mpi_sendrecv_r_col_props_a

  subroutine mpi_address_col_props_a(buf, address, ierror)
    type(col_props_t), intent(in)  :: buf(:)
    type(mpi_address_t), intent(out) :: address
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_address
    call mpi_address(buf, address, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_address_col_props_a

  subroutine mpi_pack_col_props_a(sendbuf,  recvbuf, position, comm, ierror)
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(inout) :: position
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_pack
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_pack(sendbuf,size(sendbuf),fmpi_col_props_t,recvbuf,size(recvbuf),position,comm_o,ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_pack_col_props_a

  subroutine mpi_unpack_col_props_a(sendbuf, position, recvbuf, comm, ierror)
    type(col_props_t), intent(in)  :: sendbuf(:)
    integer, intent(inout) :: position
    type(col_props_t), intent(out) :: recvbuf(:)
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_unpack
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_unpack(sendbuf, size(sendbuf), position, recvbuf, size(recvbuf), fmpi_col_props_t, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_unpack_col_props_a

  !      ... a.10  fortran bindings for collective communication  ...
  !
  ! Broadcast an array of element of the same type to all processes
  subroutine mpi_bcast_col_props_a(buf, root, comm, ierror) ! p. 152
    type(col_props_t), intent(inout) :: buf(:)
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_bcast
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(root)) root_o = fmpi_root_rank   
    call     mpi_bcast(buf, size(buf), fmpi_col_props_t, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine  mpi_bcast_col_props_a

  ! Collect elements of the same type from all processes
  subroutine mpi_gather_col_props_a(sendbuf,  recvbuf, root, comm, ierror)  ! p. 154
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_gather
    if (present(root)) root_o = fmpi_root_rank
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if


    call     mpi_gather( sendbuf, size(sendbuf), fmpi_col_props_t, recvbuf, &
         size(sendbuf), fmpi_col_props_t,root_o,comm_o,ierror_o) 


    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_gather_col_props_a


  subroutine mpi_gatherv_col_props_a(sendbuf, recvbuf, recvcounts, displs, &
       root, comm, ierror) ! p. 157
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(in)  :: recvcounts(:)
    integer, intent(in)  :: displs(size(recvcounts))
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_gatherv
    if (present(root)) root_o = root    
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_gatherv(sendbuf, size(sendbuf), fmpi_col_props_t, &
         recvbuf, recvcounts, displs, fmpi_col_props_t, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_gatherv_col_props_a

  ! My own addition that gathers an array of values from each processor
  ! allocates a pointer on the root processor
  ! recv does not have buf in the name because it is always rank 1
  ! This prevents the makefile turning it into rank two
  ! This goes wrong for character strings since len strings can't be allocated
  subroutine mpi_gathera_col_props_a(sendbuf, recv, root, comm, ierror)
    use mpi_integer_s, only : sint_gather=>fmpi_gather
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), pointer :: recv(:)
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    integer  :: recvcounts(fmpi_size)
    integer  :: displs(fmpi_size)
    integer  :: c,t
    external mpi_gatherv
    if (present(root)) root_o = root    
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    c = size(sendbuf)
    !   call mpi_gather(t,1,mpi_integer,recvcounts,1,mpi_integer,&
    !        root_o, comm_o, ierror_o)
    call sint_gather(c,recvcounts, root_o, comm_o, ierror_o)
    if (fmpi_root) then
       call calc_displ(displs, t, recvcounts)
       allocate(recv(t))
    else
       allocate(recv(0))
    end if
    call mpi_gatherv(sendbuf,c, fmpi_col_props_t, recv, recvcounts, displs, fmpi_col_props_t, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_gathera_col_props_a


  subroutine mpi_scatter_col_props_a(sendbuf, recvbuf, root, comm, ierror) ! p. 165
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_scatter
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(root)) root_o = root    
    call mpi_scatter(sendbuf, size(recvbuf), fmpi_col_props_t, recvbuf, size(recvbuf), &
         fmpi_col_props_t,root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_scatter_col_props_a

  subroutine mpi_scatterv_col_props_a(sendbuf, sendcounts, displs, recvbuf, &
       root, comm, ierror)
    type(col_props_t), intent(in)  :: sendbuf(:)
    integer, intent(in)  :: sendcounts(:)
    integer, intent(in)  :: displs(size(sendcounts))
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_scatterv
    if (present(root)) root_o = root    
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_scatterv(sendbuf, sendcounts, displs, fmpi_col_props_t, &
         recvbuf, size(recvbuf),  fmpi_col_props_t, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_scatterv_col_props_a

  ! mpi_all*** routines 
  ! Transmit  data from every processor to all the processors
  subroutine mpi_allgather_col_props_a(sendbuf,  recvbuf, comm, ierror) ! p.171
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(size(sendbuf))
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_allgather
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_allgather(sendbuf, size(sendbuf), fmpi_col_props_t, recvbuf, size(recvbuf), &
         fmpi_col_props_t, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_allgather_col_props_a

  ! p. 172
  subroutine mpi_allgatherv_col_props_a(sendbuf,  recvbuf, recvcounts, displs,comm, ierror) 
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(in)  :: recvcounts(:)
    integer, intent(in)  :: displs(size(recvcounts))
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_allgatherv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_allgatherv(sendbuf, size(sendbuf), fmpi_col_props_t, recvbuf, &
         recvcounts,   displs, fmpi_col_props_t, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_allgatherv_col_props_a

  ! Each processor sends an array to each processor 
  subroutine mpi_alltoall_col_props_a(sendbuf, recvbuf, comm, ierror) 
    type(col_props_t), intent(in)  :: sendbuf(:,:)
    type(col_props_t), intent(out) :: recvbuf(:,:)!size(sendbuf,1),size(sendbuf,2))
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_alltoall
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_alltoall(sendbuf, size(sendbuf,1), fmpi_col_props_t, recvbuf, size(recvbuf,1), &
         fmpi_col_props_t, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_alltoall_col_props_a

  ! p. 174
  subroutine mpi_alltoallv_col_props_a(sendbuf, sendcounts, sdispls, recvbuf, recvcounts, &
       rdispls, comm, ierror)
    type(col_props_t), intent(in)  :: sendbuf(:)
    integer, intent(in)  :: sendcounts(:)
    integer, intent(in)  :: sdispls(size(sendcounts))
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(in)  :: recvcounts(size(sendcounts))
    integer, intent(in)  :: rdispls(size(sendcounts))
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_alltoallv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_alltoallv(sendbuf, sendcounts, sdispls, fmpi_col_props_t, recvbuf, &
         recvcounts, rdispls, fmpi_col_props_t, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_alltoallv_col_props_a

  ! reduce a scalar on each node to a scalar on the master processor p. 177
  subroutine mpi_reduce_col_props_a( sendbuf, recvbuf, op, root, comm, ierror) 
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(:)
    type(mpi_op_t), intent(in)  :: op
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_reduce
    if (present(root)) root_o = root    
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_reduce( sendbuf, recvbuf, size(sendbuf), fmpi_col_props_t, op, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_reduce_col_props_a
  subroutine mpi_allreduce_col_props_a( sendbuf, recvbuf, op, comm, ierror) 
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(size(sendbuf))
    type(mpi_op_t), intent(in)  :: op
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_allreduce
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call  mpi_allreduce( sendbuf, recvbuf, size(sendbuf), fmpi_col_props_t, op, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_allreduce_col_props_a

  ! Each process contributes n pieces of data where n is the number of processes and recieves
  ! one piece of data from the result p. 187
  subroutine mpi_reduce_scatter_col_props_a(sendbuf, recvbuf,  recvcounts,op, comm, ierror) 
    type(col_props_t), intent(in)  :: sendbuf(:) ! Should be size of the number of processes
    type(col_props_t), intent(out) :: recvbuf(:)    ! receieve one element only
    integer, intent(in)      :: recvcounts(:)
    type(mpi_op_t), intent(in)  :: op
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_reduce_scatter
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call mpi_reduce_scatter(sendbuf,recvbuf,recvcounts,fmpi_col_props_t,op, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_reduce_scatter_col_props_a

  subroutine mpi_scan_col_props_a(sendbuf, recvbuf, op, comm, ierror) 
    type(col_props_t), intent(in)  :: sendbuf(:)
    type(col_props_t), intent(out) :: recvbuf(:)
    integer, intent(in)  :: op
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_scan
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_scan(sendbuf, recvbuf, size(sendbuf), fmpi_col_props_t, op, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_scan_col_props_a
end module user_col_props_a
  
