module user_min_part_s
  use min_part_f90_def
  use mpi_include
  use mpi_typedefs
  !  There are various sorts of name replacements to think of
  !  Fortran types              type(min_part_t)
  !  Mpi types                  fmpi_min_part_t
  !  module and function names  _min_part
  !
  !       michael hennecke
  !       a fortran 90 interface to mpi version 1.1
  !       rz uni karlsruhe, internal report 63/96
  !
  !         auxiliary module template fmpi_min_part_t_s
  !
  !         03-oct-1996, hennecke@rz.uni-karlsruhe.de (v0.9c beta)
  !
  !       permission is granted to copy and distribute this file
  !       or modified versions of this file for no fee, provided the 
  !       copyright notice and this permission notice are preserved 
  !       on all copies.
  !
  !       (c) 1996  michael hennecke, rz universitaet karlsruhe
  !
  !       This is the file for scalar choice arguments
  ! this is designed so that it will compile as is or can have types changed using sed

  implicit none
  !private
  integer, parameter, private :: count = 1  ! This module is for scalars

  ! Special function returns the mpi datatype of an argument
  public :: fmpi_get_datatype
  interface fmpi_get_datatype
     module procedure mpi_get_datatype_min_part_s
  end interface

  public :: fmpi_get_count
  interface fmpi_get_count
     module procedure mpi_get_count_min_part_s
  end interface ! mpi_get_count
  !       ... a.9  fortran bindings for point-to-point communication  ...

  public :: fmpi_send
  interface fmpi_send
     module procedure mpi_send_min_part_s
  end interface ! mpi_send

  public :: fmpi_recv
  interface fmpi_recv
     module procedure mpi_recv_min_part_s
  end interface ! mpi_recv

  public :: fmpi_bsend
  interface fmpi_bsend
     module procedure mpi_bsend_min_part_s
  end interface ! mpi_bsend

  public :: fmpi_ssend
  interface fmpi_ssend
     module procedure mpi_ssend_min_part_s
  end interface ! mpi_ssend

  public :: fmpi_rsend
  interface fmpi_rsend
     module procedure mpi_rsend_min_part_s
  end interface ! mpi_rsend

!!!     public :: fmpi_buffer_attach
  interface fmpi_buffer_attach
     module procedure mpi_buffer_attach_min_part_s
  end interface ! mpi_buffer_attach

!!!     public :: fmpi_buffer_detach
  interface fmpi_buffer_detach
     module procedure mpi_buffer_detach_min_part_s
  end interface ! mpi_buffer_detach

  public :: fmpi_isend
  interface fmpi_isend
     module procedure mpi_isend_min_part_s
  end interface ! mpi_isend

  public :: fmpi_ibsend
  interface fmpi_ibsend
     module procedure mpi_ibsend_min_part_s
  end interface ! mpi_ibsend

  public :: fmpi_issend
  interface fmpi_issend
     module procedure mpi_issend_min_part_s
  end interface ! mpi_issend

  public :: fmpi_irsend
  interface fmpi_irsend
     module procedure mpi_irsend_min_part_s
  end interface ! mpi_irsend

  public :: fmpi_irecv
  interface fmpi_irecv
     module procedure mpi_irecv_min_part_s
  end interface ! mpi_irecv

  public :: fmpi_send_init
  interface fmpi_send_init
     module procedure mpi_send_init_min_part_s
  end interface ! mpi_send_init

  public :: fmpi_bsend_init
  interface fmpi_bsend_init
     module procedure mpi_bsend_init_min_part_s
  end interface ! mpi_bsend_init

  public :: fmpi_ssend_init
  interface fmpi_ssend_init
     module procedure mpi_ssend_init_min_part_s
  end interface ! mpi_ssend_init

  public :: fmpi_rsend_init
  interface fmpi_rsend_init
     module procedure mpi_rsend_init_min_part_s
  end interface ! mpi_rsend_init

  public :: fmpi_recv_init
  interface fmpi_recv_init
     module procedure mpi_recv_init_min_part_s
  end interface ! mpi_recv_init

  public :: fmpi_sendrecv
  interface fmpi_sendrecv
     module procedure mpi_sendrecv_min_part_s
  end interface ! mpi_sendrecv

  public :: fmpi_sendrecv_replace
  interface fmpi_sendrecv_replace
     module procedure mpi_sendrecv_r_min_part_s
  end interface ! mpi_sendrecv_replace

  public :: fmpi_address
  interface fmpi_address
     module procedure mpi_address_min_part_s
  end interface ! mpi_address

!!!     public :: fmpi_pack
!!!     interface fmpi_pack
!!!       module procedure mpi_pack_min_part_s
!!!     end interface ! mpi_pack

!!!     public :: fmpi_unpack
!!!     interface fmpi_unpack
!!!       module procedure mpi_unpack_min_part_s
!!!     end interface ! mpi_unpack

  !       ... a.10  fortran bindings for collective communication  ...

  public :: fmpi_bcast
  interface fmpi_bcast
     module procedure mpi_bcast_min_part_s
  end interface ! mpi_bcast

  public :: fmpi_gather        
  interface fmpi_gather
     module procedure mpi_gather_min_part_s
  end interface ! mpi_gather

  public :: fmpi_gatherv
  interface fmpi_gatherv
     module procedure mpi_gatherv_min_part_s
  end interface ! mpi_gatherv

  public :: fmpi_scatter
  interface fmpi_scatter
     module procedure mpi_scatter_min_part_s
  end interface ! mpi_scatter

  public :: fmpi_scatterv
  interface fmpi_scatterv
     module procedure mpi_scatterv_min_part_s
  end interface ! mpi_scatterv

  public :: fmpi_allgather
  interface fmpi_allgather
     module procedure mpi_allgather_min_part_s
  end interface ! mpi_allgather

  public :: fmpi_allgatherv
  interface fmpi_allgatherv
     module procedure mpi_allgatherv_min_part_s
  end interface ! mpi_allgatherv

  public :: fmpi_alltoall
  interface fmpi_alltoall
     module procedure mpi_alltoall_min_part_s
  end interface ! mpi_alltoall

  public :: fmpi_alltoallv
  interface fmpi_alltoallv
     module procedure mpi_alltoallv_min_part_s
  end interface ! mpi_alltoallv

  public :: fmpi_reduce
  interface fmpi_reduce
     module procedure mpi_reduce_min_part_s
  end interface ! mpi_reduce

  public :: fmpi_allreduce
  interface fmpi_allreduce
     module procedure mpi_allreduce_min_part_s
  end interface ! mpi_allreduce

  public :: fmpi_reduce_scatter
  interface fmpi_reduce_scatter
     module procedure mpi_reduce_scatter_min_part_s
  end interface ! mpi_reduce_scatter

  public :: fmpi_scan
  interface fmpi_scan
     module procedure mpi_scan_min_part_s
  end interface ! mpi_scan
 	
   type(mpi_datatype_t) :: fmpi_min_part_t

contains
  ! Special function returns the mpi datatype of an argument
  function mpi_get_datatype_min_part_s(buf)
    type(min_part_t), intent(in)  :: buf
    type(mpi_datatype_t) :: mpi_get_datatype_min_part_s
    mpi_get_datatype_min_part_s = fmpi_min_part_t
  end function mpi_get_datatype_min_part_s

  ! MPI functions
  subroutine mpi_get_count_min_part_s(status, buf, count, ierror)
    type(mpi_status_t), intent(in)  :: status
    type(min_part_t), intent(in)  :: buf
    integer, intent(out) :: count
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o
    external mpi_get_count
    call mpi_get_count(status, fmpi_min_part_t, count, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_get_count_min_part_s


  ! Count and fmpi_min_part_t are never specified
  !       ... a.9  fortran bindings for point-to-point communication  ...
  ! Section 2.2
  ! Blocking send p. 18 
  subroutine mpi_send_min_part_s(buf, dest, tag, comm, ierror)
    type(min_part_t), intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_send
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_send(buf, count, fmpi_min_part_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_send_min_part_s

  ! Blocking receieve p. 22
  subroutine mpi_recv_min_part_s(buf, source, tag, status, comm, ierror)

    type(min_part_t), intent(out) :: buf
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_status_t), intent(out), optional :: status
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    type(mpi_status_t) :: status_o
    external mpi_recv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call mpi_recv(buf, count, fmpi_min_part_t, source, tag, comm_o, status_o, ierror_o)
    if (present(status)) status = status_o
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_recv_min_part_s

  subroutine mpi_bsend_min_part_s(buf, dest, tag, comm, ierror)
    type(min_part_t), intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_bsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call     mpi_bsend(buf, count, fmpi_min_part_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_bsend_min_part_s

  subroutine mpi_ssend_min_part_s(buf, dest, tag, comm, ierror)
    type(min_part_t), intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_ssend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call     mpi_ssend(buf, count, fmpi_min_part_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_ssend_min_part_s

  subroutine mpi_rsend_min_part_s(buf, dest, tag, comm, ierror)
    type(min_part_t), target, intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_rsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    call     mpi_rsend(buf, count, fmpi_min_part_t, dest, tag, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_rsend_min_part_s

  subroutine mpi_buffer_attach_min_part_s(buf, ierror)
    type(min_part_t), intent(in)  :: buf
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_buffer_attach
    call     mpi_buffer_attach(buf, count, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_buffer_attach_min_part_s

  subroutine mpi_buffer_detach_min_part_s(buf, ierror)
    type(min_part_t), intent(out) :: buf
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_buffer_detach
    call     mpi_buffer_detach(buf, count, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_buffer_detach_min_part_s

  ! immediate send p. 51
  subroutine mpi_isend_min_part_s(buf, dest, tag,  request, comm, ierror)
    type(min_part_t), target, intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_isend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_isend(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_isend_min_part_s

  subroutine mpi_ibsend_min_part_s(buf, dest, tag, request, comm, ierror)
    type(min_part_t), target, intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_ibsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_ibsend(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_ibsend_min_part_s

  subroutine mpi_issend_min_part_s(buf, dest, tag, request, comm, ierror)
    type(min_part_t), target, intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_issend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_issend(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_issend_min_part_s

  subroutine mpi_irsend_min_part_s(buf, dest, tag, request, comm, ierror)
    type(min_part_t), target, intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_irsend
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_irsend(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_irsend_min_part_s

  subroutine mpi_irecv_min_part_s(buf, source, tag, request, comm, ierror)
    type(min_part_t), target, intent(out) :: buf
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_irecv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_irecv(buf, count, fmpi_min_part_t, source, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_irecv_min_part_s

  subroutine mpi_send_init_min_part_s(buf, dest, tag, request, comm, ierror)
    type(min_part_t), intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_send_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_send_init(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_send_init_min_part_s

  subroutine mpi_bsend_init_min_part_s(buf, dest, tag, request, comm, ierror)
    type(min_part_t), intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_bsend_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_bsend_init(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_bsend_init_min_part_s

  subroutine mpi_ssend_init_min_part_s(buf, dest, tag, request, comm, ierror)
    type(min_part_t), intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_ssend_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_ssend_init(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_ssend_init_min_part_s

  subroutine mpi_rsend_init_min_part_s(buf, dest, tag, request, comm, ierror)
    type(min_part_t), target, intent(in)  :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_rsend_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_rsend_init(buf, count, fmpi_min_part_t, dest, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_rsend_init_min_part_s

  subroutine mpi_recv_init_min_part_s(buf,  source, tag, request, comm, ierror)
    type(min_part_t), target, intent(out) :: buf
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: tag
    type(mpi_request_t), intent(out) :: request
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_recv_init
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_recv_init(buf, count, fmpi_min_part_t, source, tag, comm_o, request, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_recv_init_min_part_s

  ! This is fixed to send and recieve are the same type and one scalar only
  subroutine mpi_sendrecv_min_part_s(sendbuf, dest, sendtag, recvbuf,  source, recvtag, status, comm, ierror)
    type(min_part_t), intent(in)  :: sendbuf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: sendtag
    type(min_part_t), intent(out) :: recvbuf
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: recvtag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_status_t), intent(out), optional :: status
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_status_t) :: status_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_sendrecv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_sendrecv(                                        &
         &      sendbuf, count, fmpi_min_part_t, dest, sendtag, recvbuf,       &
         &      count, fmpi_min_part_t, source, recvtag, comm_o, status_o,  ierror_o)
    if (present(ierror)) ierror = ierror_o
    if (present(status)) status = status_o
  end subroutine mpi_sendrecv_min_part_s

  subroutine mpi_sendrecv_r_min_part_s(buf, dest, sendtag, source, recvtag, status, comm,ierror)
    type(min_part_t), intent(inout) :: buf
    integer, intent(in)  :: dest
    type(mpi_tag_t), intent(in)  :: sendtag
    integer, intent(in)  :: source
    type(mpi_tag_t), intent(in)  :: recvtag
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_status_t), intent(out), optional :: status
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_status_t) :: status_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_sendrecv_replace
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_sendrecv_replace(buf, count, fmpi_min_part_t, dest, sendtag, source, recvtag,comm_o, status_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
    if (present(status)) status = status_o
  end subroutine mpi_sendrecv_r_min_part_s

  subroutine mpi_address_min_part_s(location, address, ierror)
    type(min_part_t), intent(in)  :: location
    type(mpi_address_t), intent(out) :: address
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_address
    call mpi_address(location, address, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_address_min_part_s

  subroutine mpi_pack_min_part_s(inbuf,  outbuf, position, comm, ierror)
    type(min_part_t), intent(in)  :: inbuf
    type(min_part_t), intent(out) :: outbuf
    integer, intent(inout) :: position
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_pack
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_pack(inbuf, count, fmpi_min_part_t, outbuf, count, position,comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_pack_min_part_s

  subroutine mpi_unpack_min_part_s(inbuf, position, outbuf, comm, ierror)
    type(min_part_t), intent(in)  :: inbuf
    integer, intent(inout) :: position
    type(min_part_t), intent(out) :: outbuf
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_unpack
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_unpack( inbuf, count, position, outbuf, count, fmpi_min_part_t, comm_o, ierror_o)
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_unpack_min_part_s

  !      ... a.10  fortran bindings for collective communication  ...
  !
  ! Broadcast one element of the same type to all processes
  subroutine mpi_bcast_min_part_s(buffer, root, comm, ierror) ! p. 152
    type(min_part_t), intent(inout) :: buffer
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_bcast
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(root)) root_o = fmpi_root_rank   
    call     mpi_bcast(buffer, count, fmpi_min_part_t, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine  mpi_bcast_min_part_s

  ! Collect one elements of the same type from all processes
  subroutine mpi_gather_min_part_s(sendbuf,  recvbuf, root, comm, ierror)  ! p. 154
    type(min_part_t), intent(in)  :: sendbuf
    type(min_part_t), intent(out) :: recvbuf(:) 
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_gather
    if (present(root)) root_o = fmpi_root_rank
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_gather(sendbuf, count, fmpi_min_part_t, recvbuf, count, fmpi_min_part_t, &
         root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_gather_min_part_s
  ! Collect one elements of the same type from all processes

  ! Collect one piece of information from each processor
  subroutine mpi_gatherv_min_part_s(sendbuf, recvbuf, displs, root, comm, ierror)  ! p. 154
    type(min_part_t), intent(in)  :: sendbuf
    type(min_part_t), intent(out) :: recvbuf(:) 
    integer, intent(in) :: displs(:)
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    integer :: recvcounts(size(displs))
    external mpi_gatherv
    recvcounts = count
    if (present(root)) root_o = fmpi_root_rank
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_gatherv(sendbuf, count, fmpi_min_part_t, recvbuf, recvcounts, displs, &
         fmpi_min_part_t, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_gatherv_min_part_s

  ! Collect one piece of information from each processor
  subroutine mpi_allgatherv_min_part_s(sendbuf, recvbuf, displs, comm, ierror)  ! p. 154
    type(min_part_t), intent(in)  :: sendbuf
    type(min_part_t), intent(out) :: recvbuf(:) 
    integer, intent(in) :: displs(:)
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    integer :: recvcounts(size(displs))
    external mpi_allgatherv
    recvcounts = count
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_allgatherv(sendbuf, count, fmpi_min_part_t, recvbuf, recvcounts, displs, fmpi_min_part_t, &
         comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_allgatherv_min_part_s

  ! Send one piece of information to each processor
  subroutine mpi_scatter_min_part_s(sendbuf, recvbuf, root, comm, ierror) ! p. 165
    type(min_part_t), intent(in)  :: sendbuf(:)
    type(min_part_t), intent(out) :: recvbuf
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_scatter
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(root)) root_o = root    
    call mpi_scatter(sendbuf, count, fmpi_min_part_t, recvbuf, count, fmpi_min_part_t, &
         root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_scatter_min_part_s

  ! Send one piece of information to each processor in arbitary order from root
  subroutine mpi_scatterv_min_part_s(sendbuf, displs, recvbuf,  root, comm, ierror)! p. 165
    type(min_part_t), intent(in)  :: sendbuf(:)
    type(min_part_t), intent(out) :: recvbuf
    integer, intent(in)  :: displs(:)  ! does not need to be the same size as sendbuf
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    integer sendcounts(size(displs))
    external mpi_scatterv
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(root)) root_o = root    
    sendcounts = count
    call mpi_scatterv(sendbuf, sendcounts, displs, fmpi_min_part_t, recvbuf, count, &
         fmpi_min_part_t, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_scatterv_min_part_s



  ! Transmit one piece of data from every processor to all the processors
  subroutine mpi_allgather_min_part_s(sendbuf,  recvbuf, comm, ierror) ! p.171
    type(min_part_t), intent(in)  :: sendbuf
    type(min_part_t), intent(out) :: recvbuf(:)
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_allgather
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_allgather(sendbuf, count, fmpi_min_part_t, recvbuf, count, fmpi_min_part_t, &
         comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_allgather_min_part_s
  ! Each processor sends one elements to each processor
  subroutine mpi_alltoall_min_part_s(sendbuf, recvbuf, comm, ierror) 
    type(min_part_t), intent(in)  :: sendbuf(:)
    type(min_part_t), intent(out) :: recvbuf(size(sendbuf))
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    external mpi_alltoall
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_alltoall(sendbuf, count, fmpi_min_part_t, recvbuf, count, fmpi_min_part_t, &
         comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_alltoall_min_part_s

  ! Each processor sends one elements to each processor 
  ! elements are taken in arbitary orders and put into arbitary places
  subroutine mpi_alltoallv_min_part_s(sendbuf, sdispls, recvbuf, rdispls, comm, ierror) 
    type(min_part_t), intent(in)  :: sendbuf(:)
    type(min_part_t), intent(out) :: recvbuf(:)
    integer, intent(in) :: sdispls(:), rdispls(size(sdispls))
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_ierr_t) :: ierror_o 
    integer counts(size(sdispls))
    external mpi_alltoallv
    counts = count ! One element from each
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call mpi_alltoallv(sendbuf, counts, sdispls, fmpi_min_part_t, &
         recvbuf, counts, rdispls, fmpi_min_part_t, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_alltoallv_min_part_s


  ! reduce a scalar on each node to a scalar on the master processor p. 177
  subroutine mpi_reduce_min_part_s( sendbuf, recvbuf, op, root, comm, ierror) 
    type(min_part_t), intent(in)  :: sendbuf
    type(min_part_t), intent(out) :: recvbuf
    type(mpi_op_t), intent(in)  :: op
    integer, intent(in), optional  :: root
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    integer          :: root_o = fmpi_root_rank
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_reduce
    if (present(root)) root_o = root    
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_reduce( sendbuf, recvbuf, count, fmpi_min_part_t, op, root_o, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_reduce_min_part_s
  subroutine mpi_allreduce_min_part_s( sendbuf, recvbuf, op,  comm, ierror) 
    type(min_part_t), intent(in)  :: sendbuf
    type(min_part_t), intent(out) :: recvbuf
    type(mpi_op_t), intent(in)  :: op
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_allreduce
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    call     mpi_allreduce( sendbuf, recvbuf, count, fmpi_min_part_t, op,  comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_allreduce_min_part_s

  ! Each process contributes n pieces of data where n is the number of processes and recieves
  ! one piece of data from the result p. 187
  subroutine mpi_reduce_scatter_min_part_s(sendbuf, recvbuf,  op, comm, ierror) 
    type(min_part_t), intent(in)  :: sendbuf(:) ! Should be size of the number of processes
    type(min_part_t), intent(out) :: recvbuf    ! receieve one element only
    type(mpi_op_t), intent(in)  :: op
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    integer  :: recvcounts(size(sendbuf))
    external mpi_reduce_scatter
    if (present(comm)) then
       comm_o = comm    
    else
       comm_o = fmpi_comm
    end if

    if (present(ierror)) ierror = ierror_o
    recvcounts = 1
    call     mpi_reduce_scatter(sendbuf, recvbuf, recvcounts, fmpi_min_part_t, op, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_reduce_scatter_min_part_s

  subroutine mpi_scan_min_part_s(sendbuf, recvbuf, op, comm, ierror) 
    type(min_part_t), intent(in)  :: sendbuf
    type(min_part_t), intent(out) :: recvbuf
    integer, intent(in)  :: op
    type(mpi_comm_t), intent(in), optional  :: comm
    type(mpi_ierr_t), intent(out), optional :: ierror 
    type(mpi_comm_t) :: comm_o
    type(mpi_ierr_t) :: ierror_o 
    external mpi_scan
    if (present(comm)) then
       comm_o = comm    
    else	
       comm_o = fmpi_comm
    end if

    call     mpi_scan(sendbuf, recvbuf, count, fmpi_min_part_t, op, comm_o, ierror_o) 
    if (present(ierror)) ierror = ierror_o
  end subroutine mpi_scan_min_part_s

end module user_min_part_s
  
